var Buttons = function() {
  this.default_tint_empty = "red";
  this.default_tint_highlited = "blue";
};
Buttons.prototype = {constructor:Buttons, create:function() {
  this.clickEffect = game.add.audio("click");
  this.clickEffect.allowMultiple = true;
}, addSoundOnClick:function(btn, effectKey) {
  sound = game.sound.add(effectKey);
  btn.onInputDown.add(function() {
    sound.play();
  }, this);
}, createSpriteImgButton2:function(x, y, btnKey, callback, callbackContext, scaleOnDown, parentGroup) {
  var buttonClicked = false;
  var btn = game.add.button(x, y, btnKey);
  btn.isClickable = true;
  var tempScale = btn.scale;
  btn.scaleOnDown = scaleOnDown;
  btn.callback = callback;
  btn.clbckCtx = callbackContext || this;
  btn.events.onInputDown.add(callback, callbackContext);
  setObjectAnchor(btn, .5, .5);
  btn.tint_empty = this.default_tint_highlited;
  btn.tint_highlited = this.default_tint_empty;
  if (scaleOnDown !== -1) {
    btn.events.onInputDown.add(function() {
      if (buttonClicked) {
        return;
      }
      buttonClicked = true;
      var tween = game.add.tween(btn.scale);
      tween.to({x:btn.scale.x + scaleOnDown, y:btn.scale.y + scaleOnDown}, 100, Phaser.Easing.Linear.None);
      tween.onComplete.addOnce(function() {
        var tw = game.add.tween(btn.scale).to({x:btn.scale.x - scaleOnDown, y:btn.scale.y - scaleOnDown}, 100, Phaser.Easing.Linear.None);
        tw.onComplete.add(function() {
          buttonClicked = false;
        }, this);
        tw.start();
      }, this);
      tween.start();
    }, this);
  }
  if (parentGroup != null) {
    parentGroup.addChild(btn);
  }
  return btn;
}, createSpriteImgButton:function(x, y, sizeX, sizeY, btnKey, spriteSheetkey, callback, callbackContext, scaleOnDown, parentGroup) {
  var buttonClicked = false;
  var btn = game.add.button(x, y, spriteSheetkey);
  btn.frameName = btnKey;
  btn.width = sizeX;
  btn.height = sizeY;
  btn.isClickable = true;
  var tempScale = btn.scale;
  btn.scaleOnDown = scaleOnDown;
  btn.callback = callback;
  btn.clbckCtx = callbackContext || this;
  btn.events.onInputDown.add(callback, callbackContext);
  setObjectAnchor(btn, .5, .5);
  btn.tint_empty = this.default_tint_highlited;
  btn.tint_highlited = this.default_tint_empty;
  if (scaleOnDown !== -1) {
    btn.events.onInputDown.add(function() {
      if (buttonClicked) {
        return;
      }
      buttonClicked = true;
      var tween = game.add.tween(btn.scale);
      tween.to({x:btn.scale.x + scaleOnDown, y:btn.scale.y + scaleOnDown}, 100, Phaser.Easing.Linear.None);
      tween.onComplete.addOnce(function() {
        var tw = game.add.tween(btn.scale).to({x:btn.scale.x - scaleOnDown, y:btn.scale.y - scaleOnDown}, 100, Phaser.Easing.Linear.None);
        tw.onComplete.add(function() {
          buttonClicked = false;
        }, this);
        tw.start();
      }, this);
      tween.start();
    }, this);
  }
  if (parentGroup != null) {
    parentGroup.addChild(btn);
  }
  return btn;
}, createOneImgButton:function(x, y, sizeX, sizeY, btnKey, callback, callbackContext, scaleOnDown, parentGroup) {
  var buttonClicked = false;
  var btn = game.add.button(x, y, btnKey);
  btn.width = sizeX;
  btn.height = sizeY;
  btn.position.x = x;
  btn.position.y = y;
  btn.isClickable = true;
  var tempScale = btn.scale;
  btn.scaleOnDown = scaleOnDown;
  btn.callback = callback;
  btn.clbckCtx = callbackContext || this;
  btn.events.onInputDown.add(callback, callbackContext);
  setObjectAnchor(btn, .5, .5);
  btn.tint_empty = this.default_tint_highlited;
  btn.tint_highlited = this.default_tint_empty;
  if (scaleOnDown !== -1) {
    btn.events.onInputDown.add(function() {
      if (buttonClicked) {
        return;
      }
      buttonClicked = true;
      var tween = game.add.tween(btn.scale);
      tween.to({x:btn.scale.x + scaleOnDown, y:btn.scale.y + scaleOnDown}, 100, Phaser.Easing.Linear.None);
      tween.onComplete.addOnce(function() {
        var tw = game.add.tween(btn.scale).to({x:btn.scale.x - scaleOnDown, y:btn.scale.y - scaleOnDown}, 100, Phaser.Easing.Linear.None);
        tw.onComplete.add(function() {
          buttonClicked = false;
        }, this);
        tw.start();
      }, this);
      tween.start();
    }, this);
  }
  if (parentGroup != null) {
    parentGroup.addChild(btn);
  }
  return btn;
}};

