var GameData = function() {
};
GameData.BuildTitle = "Mandala Coloring Book";
GameData.BuildVersion = "1.0.5";
GameData.BuildString = "31.03.2022";
GameData.Copyright = "Inlogic Games 2022";
console.info("%c %c   " + GameData.Copyright + " | " + GameData.BuildTitle + " " + GameData.BuildVersion + " | " + GameData.BuildString + "  %c ", "background:#353AFB", "background:#000080;color:#fff", "background:#353AFB");
var storageSaveId = "inl_mandala";
var categories = ["animals", "autumn", "exclusive", "florals", "food", "history", "mandalas", "ocean", "patterns", "space", "sphere", "winter"];
var imagesPerCategory = [6, 4, 5, 4, 2, 1, 5, 4, 6, 2, 4, 3];
var rewardCooldown = [1, 5, 20, 60, 120];
var gameData;
function unlockAllLevels() {
  var unlockedLevels = [];
  for (var i = 0;i < categories.length;i++) {
    unlockedLevels.push(imagesPerCategory[i] * 3);
  }
  return unlockedLevels;
}
function saveImage(movesMade) {
  savedLevel = movesMade.mapIndex;
  isLevelNew = true;
  for (var i = 0;i < gameData.length;i++) {
    if (gameData[i].mapIndex === movesMade.mapIndex) {
      gameData[i] = movesMade;
      isLevelNew = false;
      break;
    }
  }
  if (isLevelNew == true) {
    gameData.push(movesMade);
  }
  try {
    localStorage.setItem(storageSaveId, JSON.stringify(gameData));
  } catch (err) {
  }
}
function saveData() {
  try {
    localStorage.setItem(storageSaveId, JSON.stringify(gameData));
  } catch (err) {
  }
}
function getUnlockedLevels() {
  return gameData[0].unlockedLevels;
}
function unlockStartingLevels() {
  unlockedLevels = [];
  for (var i = 0;i < categories.length;i++) {
    unlockedLevels.push(imagesPerCategory[i]);
  }
  return unlockedLevels;
}
function loadGameData() {
  var save = localStorage.getItem(storageSaveId);
  if (save) { gameData = JSON.parse(save); }
  if (gameData == null) {
    unlockedLevels = unlockStartingLevels();
    gameData = [];
    gameData.push({unlockedLevels:unlockedLevels, rewards:{availableTime:Date.now(), pickedUpTimes:0}, effectsAllowed:true, musicAllowed:true});
  }
  if (gameData[0].rewards == null) {
    gameData[0].rewards = {availableTime:Date.now(), pickedUpTimes:0};
  }
  if (gameData[0].unlockedLevels == null) {
    gameData[0].unlockedLevels = unlockStartingLevels();
  }
}
function loadLevel(levelIndex) {
  for (var i = 0;i < gameData.length;i++) {
    if (gameData[i].mapIndex == levelIndex) {
      return gameData[i];
    }
  }
  return null;
}
function unlockLevel(categoryIndex) {
  if (gameData[0].unlockedLevels[categoryIndex] < imagesPerCategory[categoryIndex] * 3) {
    gameData[0].unlockedLevels[categoryIndex]++;
  }
  saveData();
}
;
