var ORIENTATION_PORTRAIT = 0;
var ORIENTATION_LANDSCAPE = 1;
var GAME_CURRENT_ORIENTATION = ORIENTATION_LANDSCAPE;
var game_resolutions = {1:{xMin:940, xMax:2125, y:750}};
var maxGameResolution = {x:game_resolutions[1]["xMax"], y:game_resolutions[1]["y"]};
var minGameWidth = game_resolutions[1]["xMin"];
function onGameResize() {
  var prevGameWidth = game.width;
  var prevGameHeight = game.height;
  var prevGameOrientation = GAME_CURRENT_ORIENTATION;
  if (game === null) {
    return;
  }
  var docWidth = document.documentElement.clientWidth;
  var docHeight = document.documentElement.clientHeight;
  if (RUNNING_ON_IOS) {
    if (docWidth > docHeight) {
      docWidth = window.innerWidth;
      docHeight = window.innerHeight;
    }
  }
  GAME_CURRENT_ORIENTATION = ORIENTATION_LANDSCAPE;
  resolutionY = game_resolutions[GAME_CURRENT_ORIENTATION].y;
  var aspect = docWidth / docHeight;
  resolutionX = Math.floor(resolutionY * aspect);
  if (isNaN(resolutionX)) {
    resolutionX = 0;
  }
  if (resolutionX < game_resolutions[GAME_CURRENT_ORIENTATION].xMin) {
    resolutionX = game_resolutions[GAME_CURRENT_ORIENTATION].xMin;
  }
  if (resolutionX > game_resolutions[GAME_CURRENT_ORIENTATION].xMax) {
    resolutionX = game_resolutions[GAME_CURRENT_ORIENTATION].xMax;
  }
  if (docHeight > docWidth) {
    GAME_CURRENT_ORIENTATION = ORIENTATION_PORTRAIT;
  } else {
  }
  if (prevGameOrientation !== GAME_CURRENT_ORIENTATION) {
    if (GAME_CURRENT_ORIENTATION === ORIENTATION_LANDSCAPE) {
      leaveIncorrectOrientation();
    } else {
      enterIncorrectOrientation();
    }
  }
  if (prevGameWidth === resolutionX && prevGameHeight === resolutionY && prevGameOrientation === GAME_CURRENT_ORIENTATION) {
    return;
  }
  game.scale.fullScreenScaleMode = Phaser.ScaleManager.SHOW_ALL;
  game.scale.scaleMode = Phaser.ScaleManager.SHOW_ALL;
  game.scale.refresh();
  game.scale.setGameSize(resolutionX, resolutionY);
  var gameCanvas = document.getElementById("gameCanvas");
  var container = gameCanvas.parentElement;
  var offsetWidth = container.clientWidth - game.canvas.clientWidth;
  var offsetHeight = container.clientHeight - game.canvas.clientHeight;
  game.canvas.style.left = offsetWidth > 0 ? offsetWidth * 100 / container.clientWidth / 2 + "%" : 0;
  game.canvas.style.top = offsetHeight > 0 ? offsetHeight * 100 / container.clientHeight / 2 + "%" : 0;
  if (guiManager !== null) {
    guiManager.screenSwitcher_onResolutionChange();
  }
  if (Preloader.instance != null && appState == null) {
    Preloader.instance.onResolutionChange();
  }
}
;
