var RUNNING_ON_IOS = false;
var userAgent = navigator.userAgent || navigator.vendor || window.opera;
if (userAgent.match(/iPad/i) || userAgent.match(/iPhone/i) || userAgent.match(/iPod/i)) {
  RUNNING_ON_IOS = true;
}
var partnerName = "zWebStorm";
window["partnerName"] = partnerName;
function generateMatrix(rows, cols) {
  var matrix = [];
  for (var row = 0;row < rows;row++) {
    var arRow = new Array(cols);
    for (var col = 0;col < cols;col++) {
      arRow[col] = 0;
    }
    matrix.push(arRow);
  }
  return matrix;
}
function dayofyear(d) {
  var yn = d.getFullYear();
  var mn = d.getMonth();
  var dn = d.getDate();
  var d1 = new Date(yn, 0, 1, 12, 0, 0);
  var d2 = new Date(yn, mn, dn, 12, 0, 0);
  var ddiff = Math.round((d2 - d1) / 864E5);
  return ddiff + 1;
}
function generateIndexMatrix(rows, cols) {
  var matrix = [];
  for (var row = 0;row < rows;row++) {
    var arRow = new Array(cols);
    for (var col = 0;col < cols;col++) {
      arRow[col] = index = (row * cols + col) * 4;
    }
    matrix.push(arRow);
  }
  return matrix;
}
function dayofyear(d) {
  var yn = d.getFullYear();
  var mn = d.getMonth();
  var dn = d.getDate();
  var d1 = new Date(yn, 0, 1, 12, 0, 0);
  var d2 = new Date(yn, mn, dn, 12, 0, 0);
  var ddiff = Math.round((d2 - d1) / 864E5);
  return ddiff + 1;
}
function convertImageFromRGB(image, matrix, color) {
  var blackColor = {r:0, g:0, b:0};
  var white = {r:255, g:255, b:255};
  for (var y = 0;y < image.height;y++) {
    for (var x = 0;x < image.width;x++) {
      var pixel = image.getPixel(x, y);
      index = (y * image.width + x) * 4;
      if (pixel[color] > 10) {
        matrix[y][x] = 1;
        image.imageData.data[index] = blackColor.r;
        image.imageData.data[index + 1] = blackColor.g;
        image.imageData.data[index + 2] = blackColor.b;
      } else {
        matrix[y][x] = 0;
        image.imageData.data[index] = white.r;
        image.imageData.data[index + 1] = white.g;
        image.imageData.data[index + 2] = white.b;
        image.imageData.data[index + 3] = 0;
      }
    }
  }
  image.context.putImageData(image.imageData, 0, 0);
  sprite = image.addToWorld();
  sprite.visible = false;
  sprite.isClickable = true;
  return guiManager.buttonCreator.createOneImgButton(posX, posY, image.width, image.height, sprite.key, function() {
  }, this, -1, null);
}
function updateGameSize() {
  isWideScreen();
  var resX = document.documentElement.clientWidth;
  var resY = document.documentElement.clientHeight;
  if (RUNNING_ON_IOS) {
    resX = window.innerWidth;
    resY = window.innerHeight;
  }
  if (resY < 450) {
    resX = resX / resY * 450;
    resY = 450;
  }
  if (game.device.desktop) {
    if (resX < resY) {
      resX = resY;
    }
    if (resX > resY * 6) {
      resX = resY * 6;
    }
  }
  
  game.scale.setGameSize(resX, resY);
  game.scale.refresh();

  centerGame();
  setTimeout(centerGame, 500);
}
function centerGame() {
  var container = game.canvas.parentElement;
  var offsetWidth = container.clientWidth - game.canvas.clientWidth;
  var offsetHeight = container.clientHeight - game.canvas.clientHeight;

  if(offsetWidth > 0) {
    game.canvas.style.left = (((offsetWidth * 100) / container.clientWidth) / 2) + "%";
  } else {
    game.canvas.style.left = 0;
  }

  if(offsetHeight > 0) {
    game.canvas.style.top = (((offsetHeight * 100) / container.clientHeight) / 2) + "%";
  } else {
    game.canvas.style.top = 0;
  }

  container.style.backgroundColor = "#fff";
};
function processScroll(scrollGroup, orientation, inputDownLock, initialMousePosition, scrollSpeed) {
  if (game.input.activePointer.isDown) {
    if (!inputDownLock) {
      inputDownLock = true;
      initialMousePosition = 0;
      initialMousePosition = game.input.y;
    }
    scrollSpeed = game.input.position.y - initialMousePosition;
    if (scrollGroup.position.y + scrollSpeed / 15 < 0 && scrollGroup + scrollSpeed / 15 + 100 > game.world.height) {
      scrollGroup.position.y += scrollSpeed / 15;
    } else {
      scrollSpeed = 0;
    }
  } else {
    inputDownLock = false;
    if (scrollGroup.position.y + scrollSpeed / 15 < 0 && scrollGroup.bottom + scrollSpeed / 15 + 100 > game.world.height) {
      scrollGroup.position.y += scrollSpeed / 15;
      if (scrollSpeed > 0) {
        if (scrollSpeed - 10 > 0) {
          scrollSpeed -= 10;
        } else {
          scrollSpeed = 0;
        }
      } else {
        if (scrollSpeed + 10 < 0) {
          scrollSpeed += 10;
        } else {
          scrollSpeed = 0;
        }
      }
    } else {
      scrollSpeed = 0;
    }
  }
}
function setPosition(object, x, y) {
  object.position.x = x;
  object.position.y = y;
}
function checkTime(checkedFunction, functionName, decimals) {
  if (decimals == undefined) {
    decimals = 3;
  }
  var time = Date.now();
  checkedFunction();
  var timeAfter = Date.now();
  var sec = (timeAfter - time) / 1E3;
  if (functionName == null) {
    functionName = "";
  } else {
    functionName += " => ";
  }
}
function getMobileOS() {
  const ua = navigator.userAgent;
  if (/android/i.test(ua)) {
    return "Android";
  } else {
    if (/iPad|iPhone|iPod/.test(ua) || navigator.platform === "MacIntel" && navigator.maxTouchPoints > 1) {
      return "iOS";
    }
  }
  return "Other";
}
function isWideScreen() {
  var gameCanvas = document.getElementById("gameCanvas");
  var container = gameCanvas.parentElement;
  var docWidth = container.clientWidth;
  var docHeight = container.clientHeight;
  if (RUNNING_ON_IOS) {
      docWidth = window.innerWidth;
      docHeight = window.innerHeight;
  }
  widescreen = docWidth > docHeight;
  if (guiManager.currentScreen != null) {
    if (widescreen || game.device.desktop) {
      guiManager.currentScreen.screenGroup.visible = true;
      if (guiManager.orientationGroup != null) {
        guiManager.orientationGroup.visible = false;
      }
    } else {
      if (guiManager.orientationGroup != null) {
        guiManager.orientationBg.width = game.width;
        guiManager.orientationBg.height = game.height;
        guiManager.img_rotate.width = game.width / 2;
        guiManager.img_rotate.height = guiManager.img_rotate.width;
        setPosition(guiManager.img_rotate, game.width / 2, game.height / 2);
        setPosition(guiManager.orientationBg, game.width / 2, game.height / 2);
        guiManager.orientationGroup.visible = true;
      }
      guiManager.currentScreen.screenGroup.visible = false;
    }
  }
  
  // Destroy sounds if game is no longer available (e.g., pressing Back on a single-page application)
  if(document.getElementById("gameCanvas")==null && game!=undefined){
    game.sound.destroy()
  }
  
  return true;
}
function floodFill(row, col, newColor, image, matrix, indexMatrix, movesMade) {
  lock = false;
  matrixLen = matrix.length;
  matrixRowLen = matrix[0].length;
  row = Math.floor(row) - 100;
  col = Math.floor(col);
  fillStack = [];
  fillStack.push([row, col]);
  overalIterationTime = 0;
  r = newColor.r;
  g = newColor.g;
  b = newColor.b;
  currColor = guiManager.rgbToHex({r:r, g:g, b:b});
  totalEpmtyIteration = 0;
  var counter = 0;
  stackTime = 0;
  while (fillStack.length > 0) {
    var itm = fillStack.pop();
    var row = itm[0];
    var col = itm[1];
    counter++;
    if (row < 0 || row >= matrixLen || col < 0 || col >= matrixRowLen) {
      continue;
    }
    if (matrix[row][col] == 1 || matrix[row][col] == currColor) {
      continue;
    }
    index = indexMatrix[row][col];
    if (lock == false) {
      lock = true;
      oldColor = matrix[row][col] == 0 ? {r:230, g:230, b:230} : guiManager.hexToRgb("#" + matrix[row][col].substring(2));
      if (movesMade != null) {
        movesMade.moves.push({y:row, x:col, color:newColor, oldColor:oldColor});
      }
    }
    image.imageData.data[index] = r;
    image.imageData.data[index + 1] = g;
    image.imageData.data[index + 2] = b;
    image.imageData.data[index + 3] = 255;
    matrix[row][col] = currColor;
    fillStack.push([row + 1, col]);
    fillStack.push([row - 1, col]);
    fillStack.push([row, col + 1]);
    fillStack.push([row, col - 1]);
  }
  if (counter != 1 && !guiManager.screenMenu.loadingGroup.visible) {
    soundBoard.coloringEffect.play();
  }
  image.context.putImageData(image.imageData, 0, 0);
}
function floodFillTest(row, col, newColor, image, matrix, indexMatrix, movesMade) {
  lock = false;
  matrixLen = matrix.length;
  matrixRowLen = matrix[0].length;
  row = Math.floor(row) - 100;
  col = Math.floor(col);
  fillStack = [];
  fillStack.push([row, col]);
  overalIterationTime = 0;
  r = newColor.r;
  g = newColor.g;
  b = newColor.b;
  currColor = guiManager.rgbToHex({r:r, g:g, b:b});
  currColor = 3;
  totalEpmtyIteration = 0;
  var counter = 0;
  while (fillStack.length > 0) {
    var itm = fillStack.pop();
    var row = itm[0];
    var col = itm[1];
    counter++;
    if (row < 0 || row >= matrixLen || col < 0 || col >= matrixRowLen) {
      continue;
    }
    if (matrix[row][col] == 1 || matrix[row][col] == currColor) {
      continue;
    }
    matrix[row][col] = currColor;
    fillStack.push([row + 1, col]);
    fillStack.push([row - 1, col]);
    fillStack.push([row, col + 1]);
    fillStack.push([row, col - 1]);
  }
}
;
