var ScreenGame = function() {
  this.screenGroup = null;
  this.screnName = "ScreenGame";
};
var send_gameStart = true;
ScreenGame.prototype = {preload:function() {
  this.levelIndex = 0;
  this.categoryIndex = 0;
}, update:function() {
  if (this.zooming) {
    if (game.input.activePointer.isDown == false) {
      this.zooming = false;
      return;
    }
    this.zoomPicture(this.zoomAmmount);
  }
  var orientation = isWideScreen() ? "y" : "x";
  this.processScroll(orientation);
  if (this.colorPickerClicked) {
    this.moveColorPicker(game.input.position.x, game.input.position.y);
  }
  if (game.input.totalActivePointers > 1) {
    if (this.pinchAllowed == false) {
      this.pinchAllowed = true;
      this.initialPos1 = {};
      this.initialPos1.x = game.input.pointer1.position.x;
      this.initialPos1.y = game.input.pointer1.position.y;
      this.initialPos2 = {};
      this.initialPos2.x = game.input.pointer2.position.x;
      this.initialPos2.y = game.input.pointer2.position.y;
      this.initialZoom = this.result.height / (game.height / 100);
      this.initialResultPosition = {};
      this.initialResultPosition.x = this.result.position.x;
      this.initialResultPosition.y = this.result.position.y;
    }
  } else {
    this.processMovingPicture();
    this.pinchAllowed = false;
  }
  if (this.pinchAllowed == true) {
    this.processPinch();
  }
}, clickResetImage:function() {
  ARK_game_arena_connector.fireEventToArena("event_change");
  group = game.add.group();
  this.group = group;
  var bg = guiManager.createImage(game.width / 2, game.height / 2, game.width, game.height, "paper", group);
  this.addResizeListener(function() {
    group.width = game.width;
    group.height = game.height;
  });
  bg.inputEnabled = true;
  bg.events.onInputDown.add(function() {
    group.destroy();
  });
  var window = guiManager.createImage(game.width / 2, game.height / 2, 500, 250, "popup", group);
  window.inputEnabled = true;
  bg.alpha = .7;
  bg.tint = "black";
  var textSize = 32;
  var firstRow = game.make.text(window.position.x, window.position.y - textSize * 1.75, gameTexts.textFromID(ConfirmationText), {font:textSize + "px Roboto", fill:"white", stroke:"black", strokeThickness:5, boundsAlignH:"center", boundsAlignV:"middle"});
  var secondRow = game.make.text(window.position.x, window.position.y - textSize * .5, gameTexts.textFromID(ConfirmationText_2), {font:textSize + "px Roboto", fill:"white", stroke:"black", strokeThickness:5, boundsAlignH:"center", boundsAlignV:"middle"});
  setObjectAnchor(loadText, .5, .5);
  group.addChild(loadText);
  group.addChild(firstRow);
  group.addChild(secondRow);
  this.screenGroup.addChild(group);
  setObjectAnchor(firstRow, .5, .5);
  setObjectAnchor(secondRow, .5, .5);
  var buttonSize = window.height / 4;
  var btn_cancel = guiManager.buttonCreator.createSpriteImgButton(window.position.x - buttonSize, window.bottom - buttonSize * 1.2, buttonSize, buttonSize, "decline", "pak_icons", function() {
    group.destroy();
  }, this, -1, group);
  var btn_confirm = guiManager.buttonCreator.createSpriteImgButton(window.position.x + buttonSize, window.bottom - buttonSize * 1.2, buttonSize, buttonSize, "confirm", "pak_icons", function() {
    onGameOver();
    this.movesMade.moves = [];
    var idx = this.movesMade.mapIndex == 0 ? "00" : this.movesMade.mapIndex;
    this.movesMade.url = "";
    saveImage(this.movesMade);
    guiManager.screenMenu.screenGroup.visible = true;
    guiManager.screenMenu.showLoadingScreen();
    guiManager.loadLevel(this.categoryIndex, this.levelIndex);
    guiManager.screenMenu.hideLoadingScreen();
    guiManager.screenMenu.screenGroup.visible = false;
    group.destroy();
  }, this, -1, group);
}, processPinch:function() {
  var initialPosPointer1 = this.initialPos1;
  var initialPosPointer2 = this.initialPos2;
  var zoomMultiplier = 1 / 3;
  var pinchMoveMultiplier = game.height / 100;
  var curr_x2 = game.input.pointer2.position.x;
  var curr_x1 = game.input.pointer1.position.x;
  var curr_y2 = game.input.pointer2.position.y;
  var curr_y1 = game.input.pointer1.position.y;
  var curr_a = Math.abs(curr_x2 - curr_x1);
  var curr_b = Math.abs(curr_y2 - curr_y1);
  var distance = Math.hypot(curr_a, curr_b);
  init_x1 = initialPosPointer1.x;
  init_x2 = initialPosPointer2.x;
  init_y1 = initialPosPointer1.y;
  init_y2 = initialPosPointer2.y;
  init_a = Math.abs(init_x2 - init_x1);
  init_b = Math.abs(init_y2 - init_y1);
  var initialDistance = Math.hypot(init_a, init_b);
  var zoomAmmount = (initialDistance - distance) * zoomMultiplier;
  if (!zoomAmmount == 0) {
    this.zoomPicture(this.initialZoom - zoomAmmount, true);
    var initMidPoint = {};
    initMidPoint.x = (init_x1 + init_x2) / 2;
    initMidPoint.y = (init_y1 + init_y2) / 2;
    var currMidPoint = {};
    currMidPoint.x = (curr_x1 + curr_x2) / 2;
    currMidPoint.y = (curr_y1 + curr_y2) / 2;
    var finalMidPoint = {};
    finalMidPoint.x = (currMidPoint.x + initMidPoint.x) / 2;
    finalMidPoint.y = (currMidPoint.y + initMidPoint.y) / 2;
    var deltaX = (finalMidPoint.x - initMidPoint.x) * pinchMoveMultiplier;
    var deltaY = (finalMidPoint.y - initMidPoint.y) * pinchMoveMultiplier;
    newSpritePosition = {};
    newSpritePosition.x = this.initialResultPosition.x + deltaX;
    newSpritePosition.y = this.initialResultPosition.y + deltaY;
    var condition = false;
    bounds = {};
    var offset = 150;
    bounds.right = game.width - 150;
    bounds.left = 350;
    bounds.top = offset;
    bounds.bottom = game.height - offset;
    var posX = newSpritePosition.x;
    var posY = newSpritePosition.y;
    if (posX - this.result.width / 2 > bounds.right) {
      posX = game.width + this.result.width / 2 - offset;
    }
    if (posX + this.result.width / 2 < bounds.left) {
      posX = -this.result.width / 2 + bounds.left;
    }
    if (posY + this.result.height / 2 < bounds.top) {
      posY = -this.result.height / 2 + offset;
    }
    if (posY - this.result.height / 2 > bounds.bottom) {
      posY = game.height + this.result.height / 2 - offset;
    }
    this.result.position.x = posX;
    this.sprite.position.x = posX;
    this.result.position.y = posY;
    this.sprite.position.y = posY;
  }
  this.previousZoom = zoomAmmount;
  posX = this.result.position.x;
  posY = this.result.position.y;
  bounds = {};
  var offset = 150;
  bounds.right = game.width - 150;
  bounds.left = 350;
  bounds.top = offset;
  bounds.bottom = game.height - offset;
  if (posX - this.result.width / 2 > bounds.right) {
    posX = game.width + this.result.width / 2 - offset;
  }
  if (posX + this.result.width / 2 < bounds.left) {
    posX = -this.result.width / 2 + bounds.left;
  }
  if (posY + this.result.height / 2 < bounds.top) {
    posY = -this.result.height / 2 + offset;
  }
  if (posY - this.result.height / 2 > bounds.bottom) {
    posY = game.height + this.result.height / 2 - offset;
  }
}, create:function() {
  this.screenGroup = game.add.group();
  this.screenGroup.name = this.screnName;
  this.screenGroup.visible = false;
  this.resizeQueue = [];
  this.pinchAllowed = false;
  window.addEventListener("resize", function(event) {
    updateGameSize();
    guiManager.screenGame.resizeQueue.forEach(function(element) {
      element();
    }, this);
    game.time.events.add(500, function() {
      updateGameSize();
      guiManager.screenGame.resizeQueue.forEach(function(element) {
        element();
      }, this);
    }, this);
  }, false);
  window.addEventListener("focus", function(event) {
    if (guiManager.currentScreen != guiManager.screenGame) {
      updateGameSize();
    }
    guiManager.currentScreen.resizeQueue.forEach(function(element) {
      element();
    }, this);
    game.time.events.add(500, function() {
      if (guiManager.currentScreen != guiManager.screenGame) {
        updateGameSize();
      }
      guiManager.currentScreen.resizeQueue.forEach(function(element) {
        element();
      }, this);
    }, this);
  }, false);
  this.processScroll();
  this.movesMade = {mapIndex:this.categoryIndex * 100 + this.levelIndex, gameWidth:game.width, gameHeight:game.height, moves:[], url:"", lastColor:{category:0, color:0}};
  const numOfCategories = 18;
  this.brushCategoriesIcons = [];
  for (var i = 0;i < numOfCategories;i++) {
    this.brushCategoriesIcons.push("sprite" + (i + 1));
  }
  this.initGameConfig();
  this.settings = isWideScreen() ? this.gameConfig.widescreen : this.gameConfig.portrait;
  const numberOfColoredBrushes = 9;
  for (var i = 0;i < numberOfColoredBrushes;i++) {
    this.brushCategoriesIcons.push("brush");
  }
  this.brushCategories = [];
  this.brushScrollEnabled = false;
  this.startingMousePointX = false;
  this.initCategories();
  this.selectedColor = {};
  this.selectedColor.color = {r:255, g:25, b:25};
  this.createGameWindow();
  this.createTopPanel();
  this.createBottomPanel();
  this.resetImagePosition();
  this.highlightCategory(this.getCategoryInMiddle());
  game.input.mouseWheel.callback = function(ev) {
    guiManager.screenGame.zoomPicture(-ev.deltaY);
  };
  if (game.input.pointers.length < 2) {
    game.input.addPointer();
  }
  this.topPanelGroup.inputEnableChildren = false;
  this.bottomPanelGroup.inputEnableChildren = false;
  this.gameWindowGroup.inputEnableChildren = false;
  this.pickLastColor();
}, pickLastColor:function() {
  loadedLevel = loadLevel(this.categoryIndex * 100 + this.levelIndex);
  if (loadedLevel != null) {
    if (loadedLevel.lastColor != null) {
      var lastColor = loadedLevel.lastColor;
      lastCategory = lastColor.category;
      lastColor = lastColor.color;
      this.pickCategory(this.brushCategories[lastCategory]);
      this.highlightCategory(this.brushCategories[lastCategory]);
      this.pickColor(this.palleteCollors[lastColor]);
    } else {
    }
  }
}, addResizeListener:function(element) {
  this.resizeQueue.push(function() {
    if (guiManager.currentScreen == guiManager.screenGame) {
      element();
    }
  }.bind(this));
}, hideScreen:function() {
  this.screenGroup.visible = false;
}, drawScreen:function() {
  this.screenGroup.visible = true;
}, createBottomPanel:function() {
  var bottomPanelGroup = game.add.group();
  this.bottomPanelGroup = bottomPanelGroup;
  this.screenGroup.addChild(bottomPanelGroup);
  this.screenGroup.visible = false;
  var panelWidth = 0;
  var panelHeight = 0;
  var panelPosition = {};
  var settings = isWideScreen() ? this.gameConfig.widescreen.bottomPanelSettings : this.gameConfig.portrait.bottomPanelSettings;
  if (isWideScreen()) {
    panelHeight = settings.height;
    panelWidth = settings.width;
    panelPosition = settings.panelPosition;
  } else {
    panelWidth = game.width;
    panelHeight = game.height - this.topPanelInfo.height - this.gameWindowInfo.size;
    panelPosition = {x:game.width / 2, y:game.height - panelHeight / 2};
  }
  var panelShadow = guiManager.createImage(panelPosition.x, panelPosition.y, panelWidth, panelHeight + 4, "panel", bottomPanelGroup);
  panelShadow.visible = false;
  var bottomPanel = guiManager.createImage(panelPosition.x, panelPosition.y, panelWidth - 2, panelHeight, "panel", bottomPanelGroup);
  if (isWideScreen()) {
    panelShadow.visible = false;
    bottomPanel.visible = false;
  }
  panelShadow.tint = "black";
  var width = 0;
  var height = 0;
  var iconWidth = 0;
  var iconHeight = 0;
  var num = this.brushCategoriesIcons.length;
  var startingPositionX = 0;
  var startingPositionY = 0;
  var divider = 34;
  height = game.height > game.width ? game.height / divider : game.width / divider;
  width = height * 1.75;
  this.initBgSize = width;
  iconWidth = width * 1;
  iconHeight = height * .85;
  startingPositionX = this.getFromFullHD(150) + width / 2;
  startingPositionX = 0;
  startingPositionY = 0;
  var scrollBarGroup = game.add.group();
  this.followingScreenGroup = scrollBarGroup;
  this.followingScreenGroup.position.x = this.getFromFullHD(150) + width / 2;
  bottomPanelGroup.addChild(scrollBarGroup);
  this.selectedBgBrush = guiManager.createSprite(0, 0, width + 20, height, "pak_items", "Color_item_selected", bottomPanelGroup);
  this.selectedBgBrush.visible = false;
  colorIndex = 0;
  var colors = ["#ffe600", "#fd6a00", "#ff2020", "#bd0aff", "#592c6a", "#2763ef", "#55a73a", "#582828", "#828282"];
  brushIcons = [];
  for (var i = 0;i < num;i++) {
    offsetX = isWideScreen() ? 0 : startingPositionX + width * i;
    offsetY = isWideScreen() ? startingPositionY + height * 1.1 * i : 0;
    const bgBrush = guiManager.buttonCreator.createSpriteImgButton(startingPositionX + offsetX, startingPositionY + offsetY, width, height, "Color_item", "pak_items", function() {
    }, this, -1, scrollBarGroup);
    bgBrush.inputEnabled = true;
    bgBrush.tint = this.gameConfig.widescreen.buttonTint;
    bgBrush.onInputDown.add(function() {
      this.brushScrollEnabled = true;
      this.initp = game.input.position.y;
      if (isWideScreen()) {
        this.startingMousePointX = game.input.position.y;
      } else {
        this.startingMousePointX = game.input.position.x;
      }
    }, this);
    bgBrush.onInputUp.add(function() {
      this.brushScrollEnabled = false;
      if (Math.abs(this.initp - game.input.position.y) < 15) {
        this.pickCategory(bgBrush);
        this.highlightCategory(bgBrush);
        this.selectedColor.categoryIdx = i;
      }
    }, this);
    this.brushCategories.push(bgBrush);
    var brushIcon = guiManager.createSprite(bgBrush.position.x, bgBrush.position.y, iconWidth, iconHeight, "pak_brushes", this.brushCategoriesIcons[i], scrollBarGroup);
    if (this.brushCategoriesIcons[i] == "brush") {
      fillHeight = brushIcon.height * .9;
      fillWidth = brushIcon.width * .92;
      fill = guiManager.createSprite(bgBrush.position.x, bgBrush.position.y, fillWidth, fillHeight, "pak_brushes", this.brushCategoriesIcons[i] + "_fill", scrollBarGroup);
      fill.tint = "0x" + colors[colorIndex].substring(1);
      colorIndex++;
    }
    var shadow = guiManager.createImage(4, startingPositionY, 3, height, "bgButton", bottomPanelGroup);
    shadow.alpha = 1;
    shadow.tint = "0x" + GREY_COLOR.toString().substring(1);
    shadow.visible = false;
    var shadow = guiManager.createImage(game.width - 2, startingPositionY, 3, height, "bgButton", bottomPanelGroup);
    shadow.alpha = 1;
    shadow.tint = "0x" + GREY_COLOR.toString().substring(1);
    shadow.visible = false;
  }
  zoomBtnPosition = {};
  var zoomSize;
  var zoomBtnMargin;
  offsetX = 0;
  offsetY = 0;
  var zoomBackround;
  var zoomBgPanel;
  if (isWideScreen()) {
    zoomSize = this.gameConfig.widescreen.buttonSize;
    zoomBtnPosition.x = bottomPanel.position.x;
    zoomBtnPosition.y = game.height / 2;
    zoomBtnMargin = zoomSize * .8;
    offsetY = zoomBtnMargin;
    zoomBgPanel = guiManager.createImage(game.width, zoomBtnPosition.y, zoomSize * 3.5, zoomSize * 3.5, "roundedBG_shadowed", bottomPanelGroup);
    zoomBackround = "roundedBG_outlined";
  } else {
    zoomBackround = "kvapatko_bg";
    zoomSize = this.gameConfig.portrait.buttonSize;
    zoomBtnMargin = zoomSize * 1.1;
    zoomBtnPosition.x = bottomPanel.right - zoomSize * 2;
    zoomBtnPosition.y = bottomPanel.top + zoomSize / 2;
    offsetX = zoomBtnMargin;
  }
  var zoomBtn = guiManager.buttonCreator.createSpriteImgButton(zoomBtnPosition.x - offsetX, zoomBtnPosition.y - offsetY, zoomSize, zoomSize, "plus", "pak_icons", function() {
    this.zooming = true;
    this.zoomAmmount = 9;
  }, this, .08, bottomPanelGroup);
  zoomBtn.onInputOut.add(function() {
    this.zooming = false;
  });
  if (!isWideScreen()) {
    zoomBtn.width = -zoomSize;
  }
  zoomBtn.tint = this.settings.buttonTint;
  var plusText = game.make.text(zoomBtn.position.x, zoomBtn.position.y, "+", {font:"32px Roboto"});
  plusText.visible = false;
  bottomPanelGroup.addChild(plusText);
  setObjectAnchor(plusText, .5, .4);
  var outZoom = guiManager.buttonCreator.createSpriteImgButton(zoomBtnPosition.x + offsetX, zoomBtnPosition.y + offsetY, zoomSize, zoomSize, "minus", "pak_icons", function() {
    this.zooming = true;
    this.zoomAmmount = -9;
  }, this, .08, bottomPanelGroup);
  outZoom.tint = this.settings.buttonTint;
  zoomBtn.onInputOut.add(function() {
    this.zooming = false;
  });
  var minusText = game.make.text(outZoom.position.x, outZoom.position.y, "-", {font:"32px Roboto"});
  minusText.visible = false;
  bottomPanelGroup.addChild(minusText);
  setObjectAnchor(minusText, .5, .5);
  this.resetText = game.make.text(zoomBtnPosition.x, zoomBtnPosition.y, "100%", {font:zoomSize / 3 + "px Roboto"});
  bottomPanelGroup.addChild(this.resetText);
  setObjectAnchor(this.resetText, .5, .5);
  this.resetText.font = "Roboto";
  this.addResizeListener(function() {
    if (this.result.height < game.height) {
      this.zoomPicture(0);
    }
    var zoomAmmount = Math.floor(this.result.height / (game.height / 100));
    if (zoomAmmount < 100) {
      zoomAmmount = 100;
    }
    this.resetText.setText(zoomAmmount + "%");
    btnSize = game.height / 12;
    panelHeight = game.height;
    panelWidth = btnSize;
    panelPosition = {x:game.width - btnSize * .75, y:game.height - height / 2};
    this.gameConfig.widescreen.bottomPanelSettings.panelPosition = panelPosition;
    this.gameConfig.widescreen.buttonSize = game.height / 12;
    bottomPanel.height = panelHeight;
    bottomPanel.width = panelWidth;
    setPosition(panelShadow, panelPosition.x, panelPosition.y);
    setPosition(bottomPanel, panelPosition.x, panelPosition.y);
    zoomSize = btnSize;
    zoomBtnPosition.x = bottomPanel.position.x;
    zoomBtnPosition.y = game.height / 2;
    zoomBtnMargin = zoomSize * .8;
    offsetY = zoomBtnMargin;
    zoomBtn.width = zoomSize;
    zoomBtn.height = zoomSize;
    outZoom.width = zoomSize;
    outZoom.height = zoomSize;
    this.resetText.fontSize = zoomSize / 3;
    zoomBgPanel.width = zoomSize * 3.5;
    zoomBgPanel.height = zoomSize * 3.5;
    this.resetText.position.x = zoomBtnPosition.x;
    this.resetText.position.y = zoomBtnPosition.y;
    setPosition(plusText, zoomBtnPosition.x, zoomBtnPosition.y - offsetY);
    setPosition(minusText, zoomBtnPosition.x, zoomBtnPosition.y + offsetY);
    setPosition(zoomBgPanel, game.width, zoomBtnPosition.y);
    setPosition(zoomBtn, zoomBtnPosition.x, zoomBtnPosition.y - offsetY);
    setPosition(outZoom, zoomBtnPosition.x, zoomBtnPosition.y + offsetY);
    width = this.getFromFullHD(100);
    this.followingScreenGroup.position.x = this.getFromFullHD(150) + this.initBgSize / 2;
  }.bind(this));
  var circleSize = 0;
  var margin = 0;
  var orientation = "";
  var firstCirclePosition = {};
  var leftPanel = null;
  var leftPanelBG;
  this.palleteCollors = [];
  this.palleteGroup = game.add.group();
  bottomPanelGroup.addChild(this.palleteGroup);
  if (isWideScreen()) {
    leftPanelSize = this.getFromFullHD(150);
    leftPanelBG = guiManager.createImage(leftPanelSize / 2, game.height / 2, leftPanelSize * 1.23, game.height, "shadowedBg", this.palleteGroup);
    leftPanel = guiManager.createImage(leftPanelSize / 2, game.height / 2, leftPanelSize, game.height, "panel", this.palleteGroup);
    leftPanel.inputEnabled = true;
    circleSize = game.height / 19;
    margin = circleSize * 1.45;
    firstCirclePosition.y = margin * .75;
    firstCirclePosition.x = leftPanel.position.x;
    const startX = outZoom.position.x;
    for (var i = 0;i < this.colors[0].length;i++) {
      var randomColor = get0xRandomColor();
      var img = guiManager.buttonCreator.createOneImgButton(firstCirclePosition.x, firstCirclePosition.y + margin * i, circleSize, circleSize, "colorPallette", function() {
      }, this, .3, this.palleteGroup);
      img.tint = randomColor;
      img.inputEnabled = true;
      img.useHandCursor = true;
      img.indexCustom = i;
      img.events.onInputDown.add(function() {
        this[0].selectedColor.colorIdx = this[1].indexCustom;
        this[0].pickColor(this[1]);
      }, [this, img]);
      this.palleteCollors.push(img);
    }
  } else {
    const circleSize = bottomPanel.height / 10;
    const margin = circleSize * 1.25;
    var startY = game.height - bottomPanel.height / 2;
    var startX = game.width / 2 - (circleSize + margin * 4) / 2 + circleSize / 2;
    for (var i = 0;i < this.colors[0].length;i++) {
      if (i == 5) {
        startY -= circleSize * 1.4;
        startX = game.width / 2 - (circleSize + margin * 5) / 2 + circleSize / 2;
      }
      j = i >= 5 ? i - 5 : i;
      var randomColor = get0xRandomColor();
      var img = guiManager.buttonCreator.createOneImgButton(startX + margin * j, startY, circleSize, circleSize, "colorPallette", function() {
      }, this, .3, this.palleteGroup);
      img.tint = randomColor;
      img.inputEnabled = true;
      img.useHandCursor = true;
      img.events.onInputDown.add(function() {
        this.pickColor(img);
      }, this);
      this.palleteCollors.push(img);
    }
  }
  this.colorSelector = guiManager.createImage(0, 0, circleSize + 20, circleSize + 20, "color_selector", this.palleteGroup);
  this.colorSelector.visible = false;
  this.pickCategory(this.getCategoryInMiddle());
  this.screenGroup.addChild(bottomPanelGroup);
  var colorPickerSize;
  var colorPickerBG = "";
  if (isWideScreen()) {
    colorPickerSize = this.gameConfig.widescreen.buttonSize;
    colorPickerPos = {x:leftPanel.position.x, y:leftPanel.bottom - colorPickerSize};
    colorPickerBG = "roundedBG_outlined";
  } else {
    colorPickerBG = "kvapatko_bg";
    colorPickerSize = this.gameConfig.portrait.buttonSize;
    colorPickerPos = {x:bottomPanel.left + colorPickerSize / 2 + 4, y:bottomPanel.top + colorPickerSize / 2};
  }
  this.colorPickerButtonGroup = game.add.group();
  var colorPickerBg = guiManager.createSprite(colorPickerPos.x, colorPickerPos.y, colorPickerSize, colorPickerSize, "pak_items", colorPickerBG, this.colorPickerButtonGroup);
  colorPickerBg.tint = this.gameConfig.widescreen.buttonTint;
  var colorPickerButton = guiManager.buttonCreator.createSpriteImgButton(colorPickerBg.position.x, colorPickerBg.position.y, colorPickerSize / 2, colorPickerSize / 2, "kvapatko_male", "pak_items", function() {
    this.clickColorPickerButton();
  }, this, -1, this.colorPickerButtonGroup);
  this.colorPickerBG = colorPickerButton;
  bottomPanelGroup.addChild(this.colorPickerButtonGroup);
  this.initColorPicker();
  this.addResizeListener(function() {
    leftPanelSize = this.getFromFullHD(150);
    leftPanel.width = leftPanelSize;
    leftPanel.height = game.height;
    leftPanelBG.width = leftPanelSize * 1.23;
    leftPanelBG.height = game.height;
    setPosition(leftPanelBG, leftPanelSize / 2, game.height / 2);
    setPosition(leftPanel, leftPanelSize / 2, game.height / 2);
    circleSize = game.height / 19;
    margin = circleSize * 1.45;
    firstCirclePosition.y = margin * .75;
    firstCirclePosition.x = leftPanel.position.x;
    for (var i = 0;i < this.palleteCollors.length;i++) {
      if (circleSize > 60) {
        this.palleteCollors[i].loadTexture("colorPalletteSmall");
      } else {
        this.palleteCollors[i].loadTexture("colorPallette");
      }
      this.palleteCollors[i].width = circleSize;
      this.palleteCollors[i].height = circleSize;
      this.palleteCollors[i].position.x = firstCirclePosition.x;
      this.palleteCollors[i].position.y = firstCirclePosition.y + margin * i;
    }
    if (circleSize > 60) {
      this.colorSelector.loadTexture("color_selector_small");
    } else {
      this.colorSelector.loadTexture("color_selector");
    }
    colorPickerSize = game.height / 12;
    colorPickerPos = {x:leftPanel.position.x, y:leftPanel.bottom - colorPickerSize};
    colorPickerBg.position.y = colorPickerPos.y;
    colorPickerBg.position.x = colorPickerPos.x;
    colorPickerButton.position.x = colorPickerPos.x;
    colorPickerButton.position.y = colorPickerPos.y;
    colorPickerBg.width = colorPickerSize;
    colorPickerBg.height = colorPickerSize;
    colorPickerButton.height = colorPickerSize / 2;
    colorPickerButton.width = colorPickerSize / 2;
    this.colorSelector.width = circleSize + 20;
    this.colorSelector.height = circleSize + 20;
  }.bind(this));
}, getFromFullHD:function(x) {
  return game.width * x / 1920;
}, moveColorPicker:function(posX, posY) {
  this.colorPicker.position.x = posX;
  this.colorPicker.position.y = posY;
  this.colorPickerFill.position.y = this.colorPicker.top;
  this.colorPickerFill.position.x = posX;
  posY = this.colorPicker.top;
  translatedPosition = this.tranlatePosition(posX, posY);
  if (translatedPosition.x < 0 || translatedPosition.x >= 1024 || translatedPosition.y >= 1024 + 100 || translatedPosition.y < 100) {
    return;
  }
  color = this.matrix[translatedPosition.y - 100][translatedPosition.x];
  if (color == 0) {
    color = "0xffffff";
  } else {
    if (color == 1) {
      color = "0x000000";
    }
  }
  this.colorPickerFill.tint = color;
}, saveBitMap:function() {
  soundBoard.clickEffect.play();
  var bmd = game.make.bitmapData(1024, 1024);
  var black = {r:0, g:0, b:0};
  var white = {r:255, g:255, b:255};
  var currColor = black;
  for (var y = 0;y < 1024;y++) {
    for (var x = 0;x < 1024;x++) {
      if (this.matrix[y][x] > 1) {
        currColor = guiManager.hexToRgb("#" + this.matrix[y][x].toUpperCase().substring(2));
      } else {
        currColor = this.matrix[y][x] == 1 ? black : white;
      }
      bmd.imageData.data[this.indexMatrix[y][x]] = currColor.r;
      bmd.imageData.data[this.indexMatrix[y][x] + 1] = currColor.g;
      bmd.imageData.data[this.indexMatrix[y][x] + 2] = currColor.b;
      bmd.imageData.data[this.indexMatrix[y][x] + 3] = 255;
    }
  }
  bmd.context.putImageData(bmd.imageData, 0, 0);
  bmd.update();
  var dataURL = bmd.canvas.toDataURL("image/png");
  var data = atob(dataURL.substring("data:image/png;base64,".length));
  var asArray = new Uint8Array(data.length);
  for (var i = 0, len = data.length;i < len;++i) {
    asArray[i] = data.charCodeAt(i);
  }
  var blob = new Blob([asArray.buffer], {type:"image/png"});
  saveAs(blob, "myColoringBookImage_" + (new Date).toISOString().split("T")[0].replace(/\-/g, "").slice(2, 8) + ".png");
}, initColorPicker:function() {
  var sizeY = game.height / 7;
  var sizeX = sizeY / 3;
  this.colorPickerGroup = game.add.group();
  this.colorPickerGroup.visible = false;
  this.colorPickerFill = guiManager.createSprite(0, 0, sizeX * .5175, sizeY * .667, "pak_items", "kvapatko_fill", this.colorPickerGroup);
  setObjectAnchor(this.colorPickerFill, .5, 0);
  this.colorPickerFill.tint = "0xff0202";
  this.colorPicker = guiManager.buttonCreator.createSpriteImgButton(0, 0, sizeX, sizeY, "kvapatko", "pak_items", function() {
  }, this, -1, this.colorPickerGroup);
  this.colorPicker.onInputDown.add(function() {
    this.colorPickerClicked = true;
  }, this);
  setObjectAnchor(this.colorPicker, .5, .5);
  sizeY = game.height / 10;
  sizeX = sizeY / 3;
  this.colorPickerFill.width = sizeX * .5175;
  this.colorPickerFill.height = sizeY * .667;
  this.colorPicker.width = sizeX;
  this.colorPicker.height = sizeY;
  this.colorPicker.onInputUp.add(function() {
    this.selectedColor.color = guiManager.hexToRgb("#" + this.colorPickerFill.tint.substring(2));
    this.colorPickerBG.tint = this.colorPickerFill.tint;
    this.colorSelector.visible = false;
    this.colorPickerClicked = false;
    this.palleteGroup.visible = true;
    this.colorPickerGroup.visible = false;
    this.colorPickerButtonGroup.visible = true;
    this.followingScreenGroup.visible = true;
  }, this);
  this.screenGroup.addChild(this.colorPickerGroup);
}, clickColorPickerButton:function() {
  this.colorPickerButtonGroup.visible = false;
  this.colorPickerGroup.visible = true;
  this.colorPickerClicked = true;
  this.moveColorPicker(game.width / 2, game.height * .9);
  this.screenGroup.bringToTop(this.colorPickerGroup);
  this.followingScreenGroup.visible = false;
  this.palleteGroup.visible = false;
}, selectBrushCategory:function(category) {
  const length = game.width / 2 - category.position.x - this.followingScreenGroup.position.x;
  this.selectedCategory = category;
  this.followingScreenGroup.position.x += length;
}, pickColor:function(image) {
  if (!guiManager.screenMenu.loadingGroup.visible) {
    soundBoard.colorPickEffect.play();
  }
  clickedColor = guiManager.hexToRgb("#" + image.tint.substring(2));
  this.movesMade.lastColor.color = this.palleteCollors.indexOf(image);
  saveImage(this.movesMade);
  this.colorSelector.visible = true;
  this.selectedColor.color = clickedColor;
  this.colorSelector.position = image.position;
  this.colorSelector.visible = true;
  this.colorSelector.tint = image.tint;
}, processScroll:function(orientation) {
  const sensitivity = 1;
  if (this.brushScrollEnabled && Math.abs(this.initp - game.input.position.y) >= 15) {
    this.lock = true;
    this.followingScreenGroup.position[orientation] -= (this.startingMousePointX - game.input.position[orientation]) * sensitivity;
    this.startingMousePointX = game.input.position[orientation];
    if (orientation == "y") {
    } else {
      if (this.followingScreenGroup.left > game.width / 2) {
        this.followingScreenGroup.left = game.width / 2;
      }
      if (this.followingScreenGroup.right < game.width - game.width / 2) {
        this.followingScreenGroup.right = game.width / 2;
      }
    }
  } else {
    if (this.lock) {
    }
    this.lock = false;
  }
  if (this.followingScreenGroup != null) {
    if (isWideScreen()) {
      if (this.followingScreenGroup.top > 0) {
        this.followingScreenGroup.top = 0;
      }
      if (this.followingScreenGroup.bottom < game.height) {
        this.followingScreenGroup.bottom = game.height;
      }
    } else {
      if (this.followingScreenGroup.right < game.width) {
        this.followingScreenGroup.right = game.width;
      }
      if (this.followingScreenGroup.left > 0) {
        this.followingScreenGroup.left = 0;
      }
    }
  }
}, getCategoryInMiddle:function() {
  var index = -1;
  this.brushCategories.forEach(function(element) {
    const brushIconSize = element.width / 2;
    if (element.position.x - this.followingScreenGroup.position.x > game.width / 2 - brushIconSize && element.position.x - this.followingScreenGroup.position.x < game.width / 2 + brushIconSize) {
      index = this.brushCategories.indexOf(element);
    }
  }.bind(this));
  if (index !== -1) {
    return this.brushCategories[this.brushCategories.length - 1 - index];
  }
}, highlightCategory:function(category) {
  if (category == null) {
    if (isWideScreen()) {
      category = this.brushCategories[Math.floor(this.brushCategories.length / 2)];
    } else {
      if (this.followingScreenGroup.left > game.width / 2) {
        category = this.brushCategories[0];
      } else {
        category = this.brushCategories[this.brushCategories.length - 1];
      }
    }
  }
  if (this.selectedCategory != null) {
    this.selectedCategory.frameName = "Color_item";
  }
  category.frameName = "Color_item_selected";
  curr_index = this.followingScreenGroup.getChildIndex(category);
  var element = category;
  this.selectedCategory = category;
}, getStartingPosX:function(margin, width, numberOfItems) {
  return game.width / 2 - width * numberOfItems / 2 + width / 2 - margin * (numberOfItems - 1) / 2;
}, createGameWindow:function() {
  var gameWindowGroup = game.add.group();
  this.gameWindowGroup = gameWindowGroup;
  var idx = 0;
  const imageHeight = 1024;
  bmd = game.make.bitmapData(imageHeight, imageHeight);
  category = this.categoryIndex;
  imageIndex = ~~(this.levelIndex / 3);
  color = null;
  if (this.levelIndex % 3 == 0) {
    color = "r";
  } else {
    if (this.levelIndex % 3 == 1) {
      color = "g";
    } else {
      if (this.levelIndex % 3 == 2) {
        color = "b";
      }
    }
  }
  bmd.draw(categories[this.categoryIndex] + "_" + imageIndex, 0, 0, imageHeight, imageHeight);
  bmd.update();
  var gameWindowsSettings = isWideScreen() ? this.gameConfig.widescreen.gameWindowSettings : this.gameConfig.portrait.gameWindowSettings;
  gameSize = gameWindowsSettings.gameSize;
  gameCenter = gameWindowsSettings.gameCenter;
  this.gameWindowInfo = {center:gameCenter, size:gameSize};
  this.matrix = generateMatrix(imageHeight, imageHeight);
  this.indexMatrix = generateIndexMatrix(imageHeight, imageHeight);
  var bgGame = guiManager.createImage(gameCenter.x, gameCenter.y, game.width, game.width, "panel", gameWindowGroup);
  this.addResizeListener(function() {
    bgGame.width = game.width;
    bgGame.height = game.height;
    setPosition(bgGame, game.width / 2, game.height / 2);
  });
  this.screenGroup.addChild(gameWindowGroup);
  this.screenGroup.moveDown(gameWindowGroup);
  var sprite = convertImageFromRGB(bmd, this.matrix, color);
  this.initialMatrix = this.matrix;
  sprite.position.x = gameCenter.x;
  sprite.position.y = gameCenter.y;
  gameWindowGroup.addChild(sprite);
  sprite.inputEnabled = true;
  this.newBitdata = game.make.bitmapData(imageHeight, imageHeight);
  this.initialBitmapSize = {width:this.newBitdata.width, height:this.newBitdata.height};
  this.newBitdata.draw(sprite);
  var result = this.newBitdata.addToWorld(sprite.position.x, sprite.position.y);
  result.position.x = sprite.x;
  result.position.y = sprite.y;
  result.visible = false;
  setObjectAnchor(sprite, .5, .5);
  sprite.width = gameSize;
  sprite.height = gameSize;
  result.width = gameSize;
  result.height = gameSize;
  this.newBitdata.width = gameSize;
  this.newBitdata.height = gameSize;
  sprite.tint = "0x777777";
  this.sprite = sprite;
  this.result = result;
  result.visible = false;
  gameWindowGroup.addChild(result);
  setObjectAnchor(result, .5, .5);
  this.startingPosition = {x:result.position.x, y:result.position.y, moving:false};
  sprite.events.onInputDown.add(function() {
    this.initialClickX = game.input.position.x;
    this.initialClickY = game.input.position.y;
    this.startingPosition.x = result.position.x;
    this.startingPosition.y = result.position.y;
    this.startingPosition.moving = true;
  }, this);
  sprite.events.onInputUp.add(function() {
    if (Math.abs(this.initialClickX - game.input.position.x) < 4 && Math.abs(game.input.position.y - this.initialClickY) < 4) {
      this.clickImage(result, sprite);
    }
    this.startingPosition.moving = false;
  }, this);
  loadedLevel = loadLevel(this.categoryIndex * 100 + this.levelIndex);
  this.initBitMapData = [];
  if (loadedLevel != null) {
    moves = loadedLevel.moves;
    moves.forEach(function(element) {
      floodFill(element.y + 100, element.x, element.color, this.newBitdata, this.matrix, this.indexMatrix, this.movesMade);
    }, this);
    if (moves.length > 0) {
      this.result.visible = true;
    }
  }
  this.currentZoom = this.result.height / (game.height / 100);
  this.addResizeListener(function() {
    zoom = isWideScreen() ? this.result.height / (game.height / 100) : this.result.width / (game.width / 100);
    zoom = Math.floor(zoom);
    if (zoom == 99 || zoom == 101) {
      zoom = 100;
    }
    if (zoom > 250) {
      this.result.width = game.height * this.currentZoom / 100;
      this.result.height = game.height * this.currentZoom / 100;
      this.sprite.width = game.height * this.currentZoom / 100;
      this.sprite.height = game.height * this.currentZoom / 100;
    } else {
      if (zoom < 100) {
        this.result.width = game.height;
        this.result.height = game.height;
        this.sprite.width = game.height;
        this.sprite.height = game.height;
      } else {
        this.currentZoom = zoom;
      }
    }
  }.bind(this), this);
  onGameStart();
}, resetImagePosition:function() {
}, processMovingPicture:function() {
  if ((Math.floor(this.initialClickX) == Math.floor(game.input.position.x) && Math.floor(game.input.position.y) == Math.floor(this.initialClickY)) == false && this.startingPosition.moving == true) {
    deltaY = this.initialClickY - game.input.position.y;
    deltaX = this.initialClickX - game.input.position.x;
    posX = this.startingPosition.x - deltaX;
    posY = this.startingPosition.y - deltaY;
    bounds = {};
    var offset = 150;
    bounds.right = game.width - 150;
    bounds.left = 350;
    bounds.top = offset;
    bounds.bottom = game.height - offset;
    if (posX - this.result.width / 2 > bounds.right) {
      posX = game.width + this.result.width / 2 - offset;
    }
    if (posX + this.result.width / 2 < bounds.left) {
      posX = -this.result.width / 2 + bounds.left;
    }
    if (posY + this.result.height / 2 < bounds.top) {
      posY = -this.result.height / 2 + offset;
    }
    if (posY - this.result.height / 2 > bounds.bottom) {
      posY = game.height + this.result.height / 2 - offset;
    }
    this.result.position.x = posX;
    this.sprite.position.x = posX;
    this.result.position.y = posY;
    this.sprite.position.y = posY;
  }
}, fixOutOfBounds:function() {
  posX = this.result.position.x;
  posY = this.result.position.y;
  bounds = {};
  var offset = 150;
  bounds.right = game.width - 150;
  bounds.left = 350;
  bounds.top = offset;
  bounds.bottom = game.height - offset;
  if (posX - this.result.width / 2 > bounds.right) {
    posX = game.width + this.result.width / 2 - offset;
  }
  if (posX + this.result.width / 2 < bounds.left) {
    posX = -this.result.width / 2 + bounds.left;
  }
  if (posY + this.result.height / 2 < bounds.top) {
    posY = -this.result.height / 2 + offset;
  }
  if (posY - this.result.height / 2 > bounds.bottom) {
    posY = game.height + this.result.height / 2 - offset;
  }
  this.result.position.x = posX;
  this.sprite.position.x = posX;
  this.result.position.y = posY;
  this.sprite.position.y = posY;
}, clickImage:function(resultSprite, blackAndWhiteSprite) {
  resultSprite.visible = true;
  if (this.isPictureZoomed()) {
    translatedPosition = this.tranlatePosition(this.initialClickX, this.initialClickY);
    this.newBitdata.height = this.initialBitmapSize.height;
    this.newBitdata.width = this.initialBitmapSize.width;
    floodFill(translatedPosition.y, translatedPosition.x, this.selectedColor.color, this.newBitdata, this.matrix, this.indexMatrix, this.movesMade);
    this.newBitdata.height = resultSprite.height;
    this.newBitdata.width = resultSprite.width;
  } else {
    floodFill(this.initialClickY, this.initialClickX, this.selectedColor.color, this.newBitdata, this.matrix, this.indexMatrix, this.movesMade);
  }
  this.movesMade.url = this.newBitdata.canvas.toDataURL("image/png");
  saveImage(this.movesMade);
}, initGameConfig:function() {
  var btnSize = isWideScreen() ? game.height / 12 : 100;
  this.gameConfig = {widescreen:{buttonTint:"0xdcdcdc", buttonSize:btnSize, bottomPanelSettings:{height:game.height, width:btnSize, panelPosition:{x:game.width - btnSize * .75, y:game.height - height / 2}}, gameWindowSettings:{gameSize:game.height * 1, gameCenter:{x:game.width / 2, y:game.height / 2}}}, portrait:{buttonTint:"0xc6c6c6", buttonSize:btnSize, bottomPanelSettings:{height:100, width:game.width, panelPosition:{x:game.width / 2, y:50}}, gameWindowSettings:{gameSize:game.width, gameCenter:{x:game.width / 
  2, y:100 + game.width / 2}}}};
}, zoomPicture:function(ammount, zoomPercentGiven, images) {
  if (zoomPercentGiven == undefined) {
    zoomPercentGiven = false;
  }
  if (images == undefined) {
    images = [this.result, this.sprite, this.newBitdata];
  }
  center = {};
  if (!soundBoard.clickEffect.isPlaying) {
    soundBoard.clickEffect.play();
  }
  images.forEach(function(element) {
    if (zoomPercentGiven == false) {
      if (ammount != 0) {
        if (element.height + ammount < game.height) {
          element.width = game.height;
          element.height = game.height;
          return;
        }
        if (element.width + ammount >= game.height * 2.5) {
          element.width = game.height * 2.5;
          element.height = game.height * 2.5;
        } else {
          element.width = element.width + ammount;
          element.height = element.height + ammount;
        }
        if (element != this.newBitdata) {
          if (element.height < game.size) {
            element.height = game.height;
            element.width = game.height;
          }
        }
      } else {
        element.width = game.height;
        element.height = game.height;
        if (element != this.newBitdata) {
          element.position.y = game.height / 2;
          element.position.x = game.width / 2;
        }
      }
    } else {
      if (ammount < 100 || ammount > 250) {
        return;
      }
      targetSize = ammount * (game.height / 100);
      if (element != this.newBitdata) {
        element.height = targetSize;
        element.width = targetSize;
      }
    }
  });
  var zoom = this.result.height / (game.height / 100);
  zoom = Math.floor(zoom);
  if (zoom == 99 || zoom == 101) {
    zoom = 100;
  }
  this.currentZoom = zoom;
  this.resetText.setText(zoom + "%");
  this.fixOutOfBounds();
}, tranlatePosition:function(posX, posY) {
  resultSprite = this.result;
  var curr_width, curr_height;
  curr_width = this.newBitdata.width;
  curr_height = this.newBitdata.height;
  curr_posX = resultSprite.position.x;
  curr_posY = resultSprite.position.y;
  var resultDistanceX = posX - resultSprite.left;
  var resultDistanceY = posY - resultSprite.top;
  scale = curr_width / this.initialBitmapSize.width;
  var distanceX = resultDistanceX / scale;
  var distanceY = resultDistanceY / scale + 100;
  translatedPosition = {};
  translatedPosition.x = Math.floor(distanceX);
  translatedPosition.y = Math.floor(distanceY);
  translatedPosition.scale = scale;
  return translatedPosition;
}, isPictureZoomed:function() {
  if (this.newBitdata.height == this.initialBitmapSize.height && this.newBitdata.width == this.initialBitmapSize.width) {
    return false;
  }
  return true;
}, validCoordinates:function(row, col) {
  lengthX = this.matrix.length;
  lengthY = this.matrix[row].length;
  return row >= 0 && row < lengthX && col >= 0 && col < lengthY;
}, createTopPanel:function() {
  var topPanelGroup = game.add.group();
  this.topPanelGroup = topPanelGroup;
  var topPanelWidth = 0;
  var topPanelHeight = 0;
  topPanelCenter = {};
  if (isWideScreen()) {
    topPanelWidth = game.width - gameSize;
    topPanelHeight = 100;
    topPanelCenter = {x:game.width - topPanelWidth / 2, y:topPanelHeight / 2};
  } else {
    topPanelWidth = game.width;
    topPanelHeight = 100;
    topPanelCenter = {x:game.width / 2, y:topPanelHeight / 2};
  }
  this.topPanelInfo = {width:topPanelWidth, height:topPanelHeight, center:topPanelCenter};
  this.screenGroup.addChild(topPanelGroup);
  var topPanelShaddow = guiManager.createImage(topPanelCenter.x, topPanelCenter.y, topPanelWidth, topPanelHeight * 1.01, "panel", topPanelGroup);
  topPanelShaddow.tint = "black";
  var topPanel = guiManager.createImage(topPanelCenter.x, topPanelCenter.y, topPanelWidth, topPanelHeight, "panel", topPanelGroup);
  if (isWideScreen()) {
    topPanel.visible = false;
    topPanelShaddow.visible = false;
  } else {
  }
  undoPosition = {};
  undoSize = 0;
  var bgUndo = 0;
  if (isWideScreen()) {
    undoSize = this.gameConfig.widescreen.buttonSize;
    undoPosition.x = this.gameConfig.widescreen.bottomPanelSettings.panelPosition.x;
    undoPosition.y = game.height - undoSize;
  } else {
    undoSize = topPanelHeight;
    undoPosition.x = topPanel.right - undoSize;
    undoPosition.y = topPanel.position.y;
  }
  this.undoButton = guiManager.buttonCreator.createSpriteImgButton(undoPosition.x, undoPosition.y, undoSize, undoSize, "revert", "pak_icons", function() {
    this.redoMove();
  }, this, .25, topPanelGroup);
  btnSaveInfo = {};
  btnSaveInfo.x = this.gameConfig.widescreen.bottomPanelSettings.panelPosition.x;
  btnSaveInfo.y = game.height - undoSize * 2.25;
  btnSaveInfo.size = this.gameConfig.widescreen.buttonSize;
  this.saveImageButton = guiManager.buttonCreator.createSpriteImgButton(btnSaveInfo.x, btnSaveInfo.y, btnSaveInfo.size, btnSaveInfo.size, "download", "pak_icons", function() {
    this.saveBitMap();
  }, this, .25, topPanelGroup);
  settings = {};
  menuPosition = {};
  menuSize = 0;
  if (isWideScreen()) {
    menuSize = this.gameConfig.widescreen.buttonSize;
    menuPosition.x = this.gameConfig.widescreen.bottomPanelSettings.panelPosition.x;
    menuPosition.y = menuSize;
    menuImage = "roundedBG_outlined";
  } else {
    menuSize = topPanel.height;
    menuPosition.x = menuSize / 2;
    menuPosition.y = menuSize / 2;
    menuImage = "button_new";
  }
  this.menuButtonGroup = game.add.group();
  var menuButton = guiManager.buttonCreator.createSpriteImgButton(menuPosition.x, menuPosition.y, menuSize, menuSize, "menu", "pak_icons", function() {
    this.clickButtonMenu();
  }, this, .25, this.menuButtonGroup);
  var btn_resetImage = guiManager.buttonCreator.createSpriteImgButton(this.gameConfig.widescreen.bottomPanelSettings.panelPosition.x, menuSize * 2.25, menuSize, menuSize, "reset", "pak_icons", function() {
    this.clickResetImage();
  }, this, .25, this.menuButtonGroup);
  this.addResizeListener(function() {
    undoSize = game.height / 12;
    panelPosition = {x:game.width - undoSize * .75, y:game.height - height / 2};
    undoPosition.x = panelPosition.x;
    undoPosition.y = game.height - undoSize;
    this.undoButton.width = undoSize;
    this.undoButton.height = undoSize;
    menuSize = game.height / 12;
    menuPosition.x = panelPosition.x;
    menuPosition.y = menuSize;
    menuButton.width = menuSize;
    menuButton.height = menuSize;
    btn_resetImage.width = menuSize;
    btn_resetImage.height = menuSize;
    setPosition(btn_resetImage, panelPosition.x, menuSize * 2.25);
    btnSaveInfo = {};
    btnSaveInfo.x = panelPosition.x;
    btnSaveInfo.y = game.height - undoSize * 2.25;
    btnSaveInfo.size = game.height / 12;
    this.saveImageButton.position.x = btnSaveInfo.x;
    this.saveImageButton.position.y = btnSaveInfo.y;
    this.saveImageButton.width = btnSaveInfo.size;
    this.saveImageButton.height = btnSaveInfo.size;
    setPosition(menuButton, menuPosition.x, menuPosition.y);
    setPosition(this.undoButton, undoPosition.x, undoPosition.y);
  }.bind(this));
  topPanelGroup.addChild(this.menuButtonGroup);
  this.screenGroup.addChild(topPanelGroup);
}, clickButtonMenu:function() {
  soundBoard.clickEffect.play();
  if (this.movesMade.moves.length > 0) {
    guiManager.screenMenu.playingLevel.loadTexture(this.result.texture);
  } else {
    guiManager.screenMenu.playingLevel.loadTexture(this.sprite.texture);
  }
  if (guiManager.screenMenu.playingLevel.visible == false) {
    guiManager.screenMenu.playingLevel.visible = true;
  }
  guiManager.loadScreen(guiManager.screenMenu);
  guiManager.screenMenu.resetImagePosition();
  onGameOver();
}, pickCategory:function(category) {
  if (category == null) {
    return;
  }
  const categoryIdx = this.brushCategories.indexOf(category);
  this.movesMade.lastColor.category = categoryIdx;
  saveImage(this.movesMade);
  var colorIdx = 0;
  if (categoryIdx >= this.colors.length) {
    this.palleteCollors.forEach(function(element) {
      var randomColor = get0xRandomColor();
      element.tint = randomColor;
    }, this);
    return;
  }
  this.palleteCollors.forEach(function(element) {
    element.tint = "0x" + this.colors[categoryIdx][colorIdx].substring(1);
    colorIdx++;
  }, this);
  this.pickColor(this.palleteCollors[5]);
}, initCategories:function() {
  this.colors = [["#bf8080", "#ffebb8", "#bf7c49", "#ada55a", "#5a732f", "#de3e53", "#802430", "#52161e", "#319475", "#2b7680", "#022538"], ["#b08cba", "#b830af", "#a38356", "#8c618c", "#c4729a", "#4d1731", "#94591f", "#964e93", "#8a365d", "#631548", "#6e0549"], ["#94780a", "#803e0b", "#8a416a", "#5f89b3", "#a0bd39", "#6e3255", "#631417", "#6182d4", "#545396", "#548a2d", "#354f22"], ["#cb4a2c", "#ffef00", "#55a73a", "#0c729e", "#68477b", "#661e1e", "#ec2323", "#a7811d", "#254b18", "#27385c", "#592c6a"], 
  ["#ea98ff", "#d0c0ea", "#CDC1FF", "#A594F9", "#7371FC", "#A3BFA8", "#FFEFD3", "#F7FFE0", "#F9ADA0", "#EFD5C3", "#FFD4CA"], ["#80b891", "#5a8467", "#8eb197", "#349aa8", "#6299a3", "#52973d", "#79b166", "#39716a", "#244944", "#39715c", "#39716a"], ["#d6d39f", "#d9d477", "#e3aa98", "#5b8bba", "#356da6", "#fff185", "#e0bb63", "#e0ab2d", "#b36934", "#164e87", "#072f57"], ["#E1744B", "#DC5B3B", "#DF6846", "#F38260", "#F36A48", "#D2603C", "#B45B3B", "#93452E", "#812915", "#682711", "#C65F3C"], ["#ffe3d2", 
  "#637249", "#677f3e", "#485a2e", "#395a2b", "#062039", "#0b4e92", "#0360b0", "#234139", "#536b2f", "#0f395f"], ["#7d3846", "#7770a7", "#4e5365", "#5f9391", "#629071", "#863131", "#391b44", "#353440", "#077482", "#424242", "#766b6b"], ["#FEEB9C", "#FA9626", "#FA9626", "#EE491B", "#E72718", "#C60F13", "#DB0112", "#A0060E", "#A0060E", "#86492A", "#6E0406"], ["#D4E2ED", "#E9F1F4", "#C7DFEB", "#C7DFEB", "#4BB1E1", "#7A88AB", "#AFD5E8", "#386CA8", "#1DA5E3", "#754E60", "#754E60"], ["#DA4036", "#9C0F31", 
  "#FE8325", "#FE6E65", "#C61E69", "#909A44", "#FED56B", "#09539C", "#755139", "#F89F27", "#5D613C"], ["#C5AEA8", "#C5AEA8", "#EFCCAC", "#B79476", "#8D5735", "#AD7850", "#9B7E6E", "#927054", "#775C51", "#4E2813", "#5E4338"], ["#84070D", "#B71717", "#9A7D75", "#ECF0EF", "#C5C0A2", "#356F34", "#BCACAF", "#DD785C", "#9C6F52", "#9C6F52", "#814F34"], ["#D18F38", "#E1B04A", "#B97125", "#BA8446", "#E2AF5E", "#80532C", "#BB7730", "#A45F26", "#A6713D", "#594638", "#3A261B"], ["#EFCA96", "#F5E8B1", "#ED88D4", 
  "#E9A274", "#EFB296", "#D7746E", "#F7BA2B", "#E09462", "#B83374", "#F4BBB2", "#6A2C1F"], ["#5B734F", "#D5D6C8", "#C2CDC5", "#525E50", "#777753", "#A9B7A6", "#70836F", "#CEC6B1", "#94A187", "#EFB882", "#DE9457"], ["#FFE4B2", "#FBF4A3", "#EEFC5F", "#FDE02C", "#FFF000", "#FDEB01", "#E0B978", "#F8DA60", "#FFD400", "#E3CE05", "#E4B310"], ["#FCA40F", "#E89012", "#F87B21", "#F9893D", "#F0810B", "#EB9504", "#FC6B02", "#E4660F", "#B0550F", "#944100", "#872F01"], ["#F89A8E", "#EB6077", "#FF2300", "#FB4F45", 
  "#CE4442", "#DD0908", "#BE0830", "#950018", "#7C0100", "#7C0100", "#963135"], ["#F8CAE4", "#FFA5C8", "#FAA3B6", "#F786C8", "#EA51AB", "#B7235D", "#FF0090", "#FA10BF", "#C23BA2", "#FF00FE", "#DF105E"], ["#DE73FF", "#E39EF7", "#B57DE0", "#B76AD2", "#B101E8", "#AF69ED", "#9967CA", "#8D02FF", "#81007E", "#6E2962", "#8D4585"], ["#B3E6FB", "#73C2FA", "#97C6D8", "#97C6D8", "#6692F5", "#000180", "#000180", "#0F52BA", "#42949F", "#0F4B93", "#0324EF"], ["#CFEEC2", "#C7EC47", "#4BB918", "#51C678", "#3AB042", 
  "#2D8956", "#606C2C", "#3D6F4C", "#0B6525", "#01796F", "#4E7943"], ["#F0D5B7", "#E9B687", "#D7815E", "#D7815E", "#965D28", "#84461F", "#6D3514", "#6A0912", "#5B220E", "#945F40", "#6D3514"], ["#DADEDD", "#D6CFC5", "#B4B0A4", "#9EA6A9", "#87807A", "#76797E", "#838383", "#796F6E", "#6E6F71", "#534B49", "#534B49"]];
}, isSameColor:function(color1, color2) {
  if (color1 == null) {
    return false;
  }
  if (color1.r == color2.r && color1.g == color2.g && color1.b == color2.b) {
    return true;
  }
  return false;
}, findColor:function(color) {
  this.colors.forEach(function(element) {
  });
}, redoMove:function() {
  if (this.movesMade.moves.length === 0) {
    return;
  }
  lastMove = this.movesMade.moves.pop();
  if (this.isPictureZoomed() == false) {
    floodFill(lastMove.y + 100, lastMove.x, lastMove.oldColor, this.newBitdata, this.matrix, this.indexMatrix, this.movesMade);
  } else {
    this.newBitdata.height = this.initialBitmapSize.height;
    this.newBitdata.width = this.initialBitmapSize.width;
    floodFill(lastMove.y + 100, lastMove.x, lastMove.oldColor, this.newBitdata, this.matrix, this.indexMatrix, this.movesMade);
    this.newBitdata.height = this.result.height;
    this.newBitdata.width = this.result.width;
  }
  this.movesMade.moves.pop();
  saveImage(this.movesMade);
}};
function onGameStart() {
  if (send_gameStart) {
    ARK_game_arena_connector.fireEventToArena("game_start");
    send_gameStart = false;
  }
}
function onGameOver() {
  ARK_game_arena_connector.fireEventToArena("pause_ready");
}
function get0xRandomColor() {
  var clrString = (Math.random() * 16777215 << 0).toString(16);
  while (clrString.length < 6) {
    clrString = 0 + clrString;
  }
  return "0x" + clrString;
}
;
