var ScreenMainMenu = function() {
  this.screenGroup = null;
  this.screnName = "ScreenMainMenu";
};
month = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
ScreenMainMenu.prototype = {preload:function() {
}, create:function() {
  this.resizeQueue = [];
  window.addEventListener("resize", function(event) {
    if (guiManager.currentScreen == guiManager.screenGame) {
      return;
    }
    resX = window.innerWidth;
    resY = window.innerHeight;
    updateGameSize();
    guiManager.currentScreen.resizeQueue.forEach(function(element) {
      if (guiManager.currentScreen == guiManager.screenMenu) {
        element();
      }
    });
    game.time.events.add(500, function() {
      resX = window.innerWidth;
      resY = window.innerHeight;
      updateGameSize();
      guiManager.currentScreen.resizeQueue.forEach(function(element) {
        if (guiManager.currentScreen == guiManager.screenMenu) {
          element();
        }
      });
    }, this);
  }.bind(this), false);
  window.addEventListener("focus", function(event) {
    if (guiManager.currentScreen != guiManager.screenGame) {
      return;
    }
    updateGameSize();
    guiManager.currentScreen.resizeQueue.forEach(function(element) {
      element();
    });
    game.time.events.add(500, function() {
      updateGameSize();
      guiManager.currentScreen.resizeQueue.forEach(function(element) {
        element();
      });
    }, this);
  }.bind(this), false);
  this.screenGroup = game.add.group();
  this.scale = .1;
  this.screenGroup.visible = false;
  this.levelsGroupConfig = {imageSize:350, verticalMargin:400, distanceFromTop:350};
  this.pinchAllowed = false;
  this.activeRibbon = [];
  this.levelRewarded = -1;
  this.categories = [];
  this.screenGroup.name = this.screnName;
  this.rewardPickedUpDate = gameData[0].rewards.availableTime;
  this.rewardAvailable = this.rewardPickedUpDate <= 0 ? true : false;
  this.playingLevel = null;
  this.loaded = false;
  this.orienttation = isWideScreen() ? "x" : "y";
  this.levels = [["img_1", "img_1", "img_1", "img_1", "img_1"], ["img_2", "img_2", "img_2", "img_2", "img_2", "img_2"]];
  for (var i = 0;i < 10;i++) {
    this.levels.push([]);
  }
  this.levelsGroupIcons = ["img_1", "img_2", "img_3", "img_4", "img_5", "img_6", "img_7", "img_8", "img_9", "img_10", "img_11", "img_12"];
  this.createBackground();
  checkTime(function() {
    this.createLevelGroupSelection();
  }.bind(this), "creating menu");
  this.createSettings();
  this.createLoadingDots(game.width / 2, game.height / 2, 25);
  this.loadingGroup.visible = false;
  this.inputDown = false;
  this.inputPosY = 0;
  this.initMousePositionOnDown = 0;
  this.screenGroup.visible = true;
  updateGameSize();
  this.resizeQueue.forEach(function(element) {
    element();
  });
  if (gameData[0].effectsAllowed == false) {
    this.clickButtonEffects();
  }
  if (gameData[0].musicAllowed == false) {
    this.clickButtonMusic();
  }
  this.scrollSpeed = 0;
  this.levelsGroup.visible = false;
  this.showLoadingScreen();
  var seed = dayofyear(new Date);
  var days = dayofyear(new Date) % 7;
  var min = 0;
  var max = imagesPerCategory[days] * 3;
  var randomOutput = 0;
  max = max || 1;
  min = min || 0;
  seed = (seed * 9301 + 49297) % 233280;
  var rnd = seed / 233280;
  randomOutput = parseInt(min + rnd * (max - min));
  if (gameData.length > 1 && gameData[1].mapIndex !== days * 100 + randomOutput) {
    gameData.splice(1, 2);
    saveData();
  }
  this.createLevelSelection(days, randomOutput);
}, update:function() {
}, enterFullScreen:function(btn_fullscreen) {
  screenfull.toggle();
  this.resizeQueue.forEach(function(element) {
    element();
  });
}, createScrollArrow:function() {
  this.scrollDots = game.add.group(this.screenGroup);
  var dotSize = game.height / 40;
  this.dots = [];
  var leftDot = guiManager.buttonCreator.createOneImgButton(game.width / 2 - dotSize * 1.5, game.height * .88, dotSize, dotSize, "scrollDot", function() {
    game.add.tween(this.followingScreenGroup).to({left:0}, 750, Phaser.Easing.Linear.None, true, 0);
    this.pickScrollDot(leftDot);
  }, this, .25, this.scrollDots);
  leftDot.tint = "0x" + GREY_COLOR.substring(1);
  var middleDot = guiManager.buttonCreator.createOneImgButton(game.width / 2, game.height * .88, dotSize, dotSize, "scrollDot", function() {
    game.add.tween(this.followingScreenGroup).to({left:-this.followingScreenGroup.width * .43}, 750, Phaser.Easing.Linear.None, true, 0);
    this.pickScrollDot(middleDot);
  }, this, .25, this.scrollDots);
  middleDot.tint = "0x" + GREY_COLOR_UNAVAILABLE.substring(1);
  var rightDot = guiManager.buttonCreator.createOneImgButton(game.width / 2 + dotSize * 1.5, game.height * .88, dotSize, dotSize, "scrollDot", function() {
    game.add.tween(this.followingScreenGroup).to({right:game.width}, 750, Phaser.Easing.Linear.None, true, 0);
    this.pickScrollDot(rightDot);
  }, this, .25, this.scrollDots);
  rightDot.tint = "0x" + GREY_COLOR_UNAVAILABLE.substring(1);
  this.dots.push(leftDot);
  this.dots.push(middleDot);
  this.dots.push(rightDot);
  this.resizeQueue.push(function() {
    const size = game.height / 40;
    const positions = [game.width / 2 - size * 1.5, game.width / 2, game.width / 2 + size * 1.5];
    for (var i = 0;i < this.dots.length;i++) {
      this.dots[i].width = size;
      this.dots[i].height = size;
      this.dots[i].position.x = positions[i];
      this.dots[i].position.y = game.height * .88;
    }
  }.bind(this));
  this.arrowGroup = game.add.group();
  var leftArrow = guiManager.createSprite(0, 0, 200, 200, "pak_icons", "arrow", this.arrowGroup);
  var rightArrow = guiManager.createSprite(0, 0, 200, 200, "pak_icons", "arrow", this.arrowGroup);
  leftArrow.alpha = .78;
  rightArrow.alpha = .78;
  this.leftArrow = leftArrow;
  this.rightArrow = rightArrow;
  this.arrowGroup.visible = false;
}, pickScrollDot:function(dot) {
  if (dot == null) {
    if (this.followingScreenGroup.left > -this.followingScreenGroup.width * .15) {
      dot = this.dots[0];
    } else {
      if (this.followingScreenGroup.right < game.width + this.followingScreenGroup.width * .25) {
        dot = this.dots[2];
      } else {
        dot = this.dots[1];
      }
    }
  }
  this.dots.forEach(function(element) {
    if (element == dot) {
      element.tint = "0x" + GREY_COLOR.substring(1);
    } else {
      element.tint = "0x" + GREY_COLOR_UNAVAILABLE.substring(1);
    }
  });
}, processScroll:function(orientation) {
  worldBounds = orientation == "y" ? game.height : game.width;
  groupBounds = orientation == "y" ? this.followingScreenGroup.bottom : this.followingScreenGroup.right;
  var leftMargin = 40;
  if (game.input.activePointer.isDown) {
    if (!this.inputDown) {
      this.inputDown = true;
      this.initMousePositionOnDown = 0;
      this.initMousePositionOnDown = game.input[orientation];
    }
    this.scrollSpeed = game.input.position[orientation] - this.initMousePositionOnDown;
    if (this.followingScreenGroup.left + this.scrollSpeed / 15 < leftMargin && groupBounds + this.scrollSpeed / 15 + 100 > worldBounds) {
      this.followingScreenGroup.position[orientation] += this.scrollSpeed / 15;
    } else {
      this.scrollSpeed = 0;
    }
  } else {
    this.inputDown = false;
    if (this.followingScreenGroup.left + this.scrollSpeed / 15 < leftMargin && groupBounds + this.scrollSpeed / 15 + 100 > worldBounds) {
      this.followingScreenGroup.position[orientation] += this.scrollSpeed / 15;
      if (this.scrollSpeed > 0) {
        if (this.scrollSpeed - 10 > 0) {
          this.scrollSpeed -= 10;
        } else {
          this.scrollSpeed = 0;
        }
      } else {
        if (this.scrollSpeed + 10 < 0) {
          this.scrollSpeed += 10;
        } else {
          this.scrollSpeed = 0;
        }
      }
    } else {
      this.scrollSpeed = 0;
    }
  }
  if (this.followingScreenGroup != this.settingsGroup) {
    if (this.followingScreenGroup.left > leftMargin) {
      this.scrollSpeed = 0;
      this.followingScreenGroup.left = leftMargin;
    } else {
      if (this.followingScreenGroup.right < game.width) {
        if (this.followingScreenGroup.left > leftMargin) {
          this.scrollSpeed = 0;
          this.followingScreenGroup.right = game.width;
        }
      }
    }
  }
}, hideScreen:function() {
  this.screenGroup.visible = false;
}, drawScreen:function() {
  game.input.mouseWheel.callback = function(ev) {
    guiManager.screenMenu.scrollSpeed = guiManager.screenMenu.scrollSpeed - ev.deltaY;
  };
  this.screenGroup.visible = true;
  const t = game.height / 7;
  const p = game.height - 2 * t;
  const h = game.height;
  posY = h - t - p / 2;
  posX = game.width / 2 - guiManager.screenMenu.followingScreenGroup.position.x;
  setPosition(backgrounds[0], posX, posY);
  setPosition(dateText, posX, 50);
  setPosition(btnPlay, posX, game.height - 50);
}, createBackground:function() {
  this.screenGroup = game.add.group();
  var bcgImg = game.add.image(0, 0, "bgMenu");
  bcgImg.width = resolutionX;
  bcgImg.height = resolutionY;
  this.screenGroup.addChild(bcgImg);
  this.resizeQueue.push(function() {
    bcgImg.width = game.width;
    bcgImg.height = game.height;
    bcgImg.position.x = 0;
    bcgImg.position.y = 0;
  }.bind(this));
}, createLevelGroupSelection:function() {
  const levelsNum = this.levelsGroupIcons.length;
  const imageSize = 800;
  var spriteSize;
  var margin;
  var distanceFromTop;
  if (isWideScreen()) {
    spriteSize = game.height / 3.5;
    margin = spriteSize + spriteSize / 3;
    distanceFromTop = spriteSize * .75 + spriteSize * .6;
  } else {
    spriteSize = game.width / 3;
    margin = spriteSize + spriteSize / 3;
    distanceFromTop = 150 + spriteSize * .6;
  }
  const spriteSheetKey = "pak_temp";
  this.levelsGroup = game.add.group();
  this.followingScreenGroup = this.levelsGroup;
  this.resizeQueue.push(function() {
    if (this.followingScreenGroup.right < game.width) {
      this.followingScreenGroup.right = game.width;
    }
    if (this.followingScreenGroup.left > 0) {
      this.followingScreenGroup.left = 0;
    }
  }.bind(this));
  row = 0;
  var windows = [];
  var categoriesIcons = [];
  for (var i = 0;i < levelsNum;i++) {
    if (isWideScreen()) {
      posX = distanceFromTop + margin * row;
      posY = i % 2 == 1 ? distanceFromTop + margin : distanceFromTop;
    } else {
      posX = i % 2 == 1 ? game.width * .25 : game.width * .75;
      posY = distanceFromTop + margin * row;
    }
    if (i % 2 == 1) {
      row++;
    }
    shadow = guiManager.createImage(posX, posY, spriteSize * 1.1, spriteSize * 1.1, "window", this.levelsGroup);
    windows.push(shadow);
    bmd = game.make.bitmapData(imageSize, imageSize);
    bmd.draw(categories[i] + "_0", 0, 0, imageSize, imageSize);
    bmd.update();
    var idx = "menu_" + (i * 100).toString();
    var sprite = guiManager.createImage(posX, posY, imageSize, imageSize, idx);
    sprite.events.onInputOver.add(function() {
      game.canvas.style.cursor = "pointer";
    }, this);
    sprite.events.onInputOut.add(function() {
      game.canvas.style.cursor = "default";
    }, this);
    sprite.height = spriteSize;
    sprite.width = spriteSize;
    sprite.inputEnabled = true;
    clickPos = {};
    sprite.events.onInputDown.add(function() {
      clickPos.x = Math.floor(game.input.position.x);
      clickPos.y = Math.floor(game.input.position.y);
    });
    sprite.idxx = i;
    sprite.events.onInputUp.add(function(sprite) {
      if (Math.floor(game.input.position.x) == clickPos.x && Math.floor(game.input.position.y) == clickPos.y) {
        this.scrollSpeed = 0;
        this.levelsGroup.visible = false;
        this.showLoadingScreen();
        setTimeout(function(idx) {
          checkTime(function() {
            this.createLevelSelection(idx);
            this.selectedLevelsCategory = idx;
          }.bind(this), "createLevel", 10);
        }.bind(this), 100, sprite.idxx);
        this.menuButtonGroup.visible = true;
        this.btn_menu.visible = true;
      }
    }, this);
    this.categories.push(sprite);
    setObjectAnchor(sprite, .5, .5);
    this.levelsGroup.addChild(sprite);
    categoryIconSize = spriteSize / 4;
    var categoryIcon = guiManager.createSprite(posX + sprite.width / 2, posY + sprite.height / 2, categoryIconSize, categoryIconSize, "pak_categories", categories[i], this.levelsGroup);
    categoriesIcons.push(categoryIcon);
  }
  this.categories.forEach(function(element) {
    this.resizeQueue.push(function() {
      idx = this.categories.indexOf(element);
      var posX = 0;
      var posY = 0;
      if (isWideScreen()) {
        this.orienttation = "x";
        spriteSize = Math.floor(game.height * .55);
        margin = spriteSize + spriteSize / 3;
        distanceFromTop = spriteSize * .75 + spriteSize * .6;
        topPanelHeight = game.height < 500 ? game.height / 7 : 100;
        posX = distanceFromTop + margin * (idx - 1);
        const t = game.height / 7;
        const p = game.height - 2 * t;
        const h = game.height;
        posY = h - t - p / 2;
      } else {
        this.orienttation = "y";
        margin = spriteSize + spriteSize / 3;
        distanceFromTop = 150 + spriteSize * .6;
        posX = idx % 2 == 1 ? game.width * .25 : game.width * .75;
        posY = distanceFromTop + margin * Math.floor(idx / 2);
      }
      element.height = spriteSize;
      element.width = spriteSize;
      windows[idx].height = spriteSize * 1.1;
      windows[idx].width = spriteSize * 1.1;
      categoriesIcons[idx].height = spriteSize / 4;
      categoriesIcons[idx].width = spriteSize / 4;
      setPosition(categoriesIcons[idx], posX + element.width / 2, posY + element.height / 2);
      setPosition(element, posX, posY);
      setPosition(windows[idx], posX, posY);
      if (this.followingScreenGroup.left < 40) {
        this.followingScreenGroup.left = 40;
      }
    }.bind(this));
  }, this);
  this.screenGroup.addChild(this.levelsGroup);
  this.selectedLevelsGroup = game.add.group();
  this.selectedLevelsGroup.name = "levelSelectionGroup";
  this.screenGroup.add(this.selectedLevelsGroup);
  this.selectedLevelsGroup.visible = false;
}, createRibbon:function(sprite, parrentsGroup) {
  this.destroyRibbon();
  var ribbonSize = sprite.width / 4;
  posX = sprite.position.x - sprite.width / 2 + ribbonSize / 2;
  posY = sprite.position.y - sprite.height / 2 + ribbonSize / 2;
  var ribbon = guiManager.createSprite(posX, posY, ribbonSize, ribbonSize, "pak_ribbon", "stuha", parrentsGroup);
  var star = guiManager.createSprite(posX, posY, ribbonSize, ribbonSize, "pak_ribbon", "hviezda", parrentsGroup);
  this.activeRibbon = {};
  this.activeRibbon.ribbon = ribbon;
  this.activeRibbon.star = star;
  this.activeRibbon.sprite = sprite;
  ribbon.tint = "0xff4f7b";
  this.resizeQueue.push(function() {
    var ribbonSize = sprite.width / 4;
    posX = sprite.position.x - sprite.width / 2 + ribbonSize / 2;
    posY = sprite.position.y - sprite.height / 2 + ribbonSize / 2;
    this.activeRibbon.star.position.x = posX;
    this.activeRibbon.star.position.y = posY;
    this.activeRibbon.star.height = ribbonSize;
    this.activeRibbon.star.width = ribbonSize;
    this.activeRibbon.ribbon.width = ribbonSize;
    this.activeRibbon.ribbon.height = ribbonSize;
    this.activeRibbon.ribbon.position.x = posX;
    this.activeRibbon.ribbon.position.y = posY;
  }.bind(this));
}, attachRibbon:function(sprite) {
  this.activeRibbon.sprite = sprite;
}, destroyRibbon:function() {
  if (this.activeRibbon.star == null) {
    return;
  }
  this.activeRibbon.star.visible = false;
  this.activeRibbon.ribbon.visible = false;
  if (this.activeRibbon.length > 0) {
    this.activeRibbon.ribbon.destroy();
    this.activeRibbon.star.destroy();
    this.activeRibbon.sprite = null;
  }
}, createLevelSelection:function(levelIdx, imageIndex) {
  ARK_game_arena_connector.fireEventToArena("event_change");
  this.followingScreenGroup = this.selectedLevelsGroup;
  this.selectedLevelsGroup.removeAll(true);
  this.levelsGroup.visible = false;
  const spriteSheetKey = "pak_temp";
  this.followingScreenGroup.left = 0;
  var currLevels = [];
  levelChosen = levelIdx;
  imageChosen = imageIndex;
  if (isWideScreen()) {
    imageSize = Math.floor(game.height * .6);
  } else {
    imageSize = Math.floor(game.width * .75);
  }
  curr_group = categories[levelIdx];
  for (var i = 0;i < imagesPerCategory[levelIdx];i++) {
    currLevels.push(curr_group + "_" + i);
  }
  this.selectedLevelsGroup.visible = true;
  verticalMargin = imageSize * 1.1 + 100;
  distanceFromTop = imageSize * .7;
  var sprites = [];
  unlockedLevels = getUnlockedLevels();
  if (unlockedLevels == null) {
    unlockedLevels = [];
    for (var i = 0;i < categories.length;i++) {
      unlockedLevels.push(1);
    }
    gameData.push(gameData[0]);
    gameData[0] = {unlockedLevels:unlockedLevels};
  }
  var imageFills = [];
  for (var i = 0;i < unlockedLevels[levelIdx];i++) {
    imageFills.push(null);
  }
  var unlockLevelShown = false;
  var lockedLevel = [];
  backgrounds = [];
  var unlockedSprite = null;
  for (var i = 0;i < 1;i++) {
    if (isWideScreen()) {
      const t = game.height / 7;
      const p = game.height - 2 * t;
      const h = game.height;
      posY = game.height / 2;
      posX = game.width / 2 - guiManager.screenMenu.followingScreenGroup.position.x;
    } else {
      posX = game.width / 2 - guiManager.screenMenu.followingScreenGroup.position.x;
      posY = game.height / 2;
    }
    var change = 0;
    if (imageIndex % 3 == 0) {
      currColor = "r";
    }
    if (imageIndex % 3 == 1) {
      currColor = "g";
    }
    if (imageIndex % 3 == 2) {
      currColor = "b";
    }
    change = parseInt(imageIndex / 3);
    shadow = guiManager.createImage(posX, posY, imageSize * 1.1, imageSize * 1.1, "window_square", this.selectedLevelsGroup);
    backgrounds.push(shadow);
    var size = 800;
    bmd = game.make.bitmapData(size, size);
    bmd.draw(currLevels[change], 0, 0, size, size);
    bmd.update();
    tempMatrix = generateMatrix(bmd.height, bmd.width);
    indexMatrix = generateIndexMatrix(bmd.height, bmd.width);
    var sprite = convertImageFromRGB(bmd, tempMatrix, currColor);
    sprite.height = imageSize;
    sprite.width = imageSize;
    sprite.position.x = posX;
    sprite.position.y = posY;
    dateText = game.make.text(game.width / 2, 50, gameTexts.textFromID(month[(new Date).getMonth()]) + " " + (new Date).getDate(), {font:"50px bebas_font", fill:"black", strokeThickness:2});
    dateText.anchor.x = .5;
    dateText.anchor.y = .5;
    this.selectedLevelsGroup.add(dateText);
    btnPlay = guiManager.buttonCreator.createOneImgButton(game.width / 2, game.height - 50, 212, 70, "bigBtn", function() {
      this.showLoadingScreen();
      setTimeout(function() {
        this.playingLevel = imageFills[0];
        this.playingLevel.position = sprites[0];
        this.clickLevel(levelChosen, imageChosen);
      }.bind(this), 50, sprite);
    }, this, .1, this.selectedLevelsGroup);
    playText = game.make.text(0, 0, gameTexts.textFromID("Play"), {font:"40px bebas_font", fill:"black", strokeThickness:2});
    playText.anchor.x = .5;
    playText.anchor.y = .5;
    btnPlay.addChild(playText);
    game.time.events.add(200, function() {
      const t = game.height / 7;
      const p = game.height - 2 * t;
      const h = game.height;
      posY = h - t - p / 2;
      posX = game.width / 2 - guiManager.screenMenu.followingScreenGroup.position.x;
      setPosition(backgrounds[0], posX, posY);
      setPosition(sprites[0], posX, posY);
      setPosition(dateText, posX, sprites[0].position.y - sprites[0].height / 2 - dateText.height);
      setPosition(btnPlay, posX, sprites[0].position.y + sprites[0].height / 2 + btnPlay.height);
      setTimeout(() => {
        imageFills[0].position = sprites[0].position;
      },);
    });
    var loadedLevel = loadLevel(levelIdx * 100 + imageIndex);
    if (loadedLevel != null && loadedLevel.url != null && loadedLevel.url != "") {
      var mapIndex = loadedLevel.mapIndex;
      if (mapIndex == 0) {
        mapIndex = "00";
      }
      game.load.image(mapIndex, loadedLevel.url, true);
      game.load.onLoadComplete.add(function() {
        if (loadedLevel == null) {
          mapIndex = "/";
          return;
        } else {
        }
        var imageFill = guiManager.createImage(sprite.position.x, sprite.position.y, sprite.width, sprite.height, mapIndex, this.self.selectedLevelsGroup);
        imageFill.position = sprite.position;
        if (mapIndex === "/") {
          imageFill.visible = false;
        }
        imageFills[this.idx] = imageFill;
        loadedLevel = null;
        if (imageFills.length == unlockedLevels[levelIdx]) {
        }
      }, {self:this, idx:i});
    } else {
      var imageFill = guiManager.createImage(sprite.position.x, sprite.position.y, sprite.width, sprite.height, sprite.key, this.selectedLevelsGroup);
      imageFills[i] = imageFill;
      imageFill.position = sprite.position;
    }
    sprite.inputEnabled = true;
    sprites.push(sprite);
    if (i % 3 == 2) {
      imageIndex++;
    }
    setObjectAnchor(sprite, .5, .5);
    this.selectedLevelsGroup.addChild(sprite);
  }
  game.load.start();
  if (isWideScreen()) {
    imageSize = Math.floor(game.height * .7);
  } else {
    imageSize = Math.floor(game.width * .75);
  }
  posX = game.width / 2 - guiManager.screenMenu.followingScreenGroup.position.x;
  setPosition(dateText, posX, dateText.height / 1.5);
  setPosition(btnPlay, posX, game.height - btnPlay.height / 1.5);
  btnPlay.width = imageSize / 3.5;
  btnPlay.scale.y = btnPlay.scale.x;
  dateText.width = imageSize / 2.2;
  dateText.scale.y = dateText.scale.x;
  setPosition(btnPlay, posX, sprites[0].position.y + sprites[0].height / 2 + btnPlay.height);
  setPosition(dateText, posX, sprites[0].position.y - sprites[0].height / 2 - dateText.height);
  clickPos = {};
  for (var i = 0;i < sprites.length;i++) {
    this.resizeQueue.push(function() {
      if (sprites[this.idx] != null) {
        if (guiManager.currentScreen != guiManager.screenMenu) {
          return;
        }
        if (isWideScreen()) {
          imageSize = Math.floor(game.height * .6);
        } else {
          imageSize = Math.floor(game.width * .75);
        }
        const t = game.height / 7;
        const p = game.height - 2 * t;
        const h = game.height;
        posY = h - t - p / 2;
        posX = game.width / 2 - guiManager.screenMenu.followingScreenGroup.position.x;
        sprites[this.idx].height = imageSize;
        sprites[this.idx].width = imageSize;
        backgrounds[this.idx].height = imageSize * 1.08;
        backgrounds[this.idx].width = imageSize * 1.08;
        if (imageFills[this.idx] != null) {
          imageFills[this.idx].width = sprites[this.idx].width;
          imageFills[this.idx].height = sprites[this.idx].height;
        }
        setPosition(backgrounds[this.idx], posX, posY);
        setPosition(sprites[this.idx], posX, posY);
        setPosition(dateText, posX, dateText.height / 1.5);
        btnPlay.width = imageSize / 3.5;
        btnPlay.scale.y = btnPlay.scale.x;
        dateText.width = imageSize / 2.2;
        dateText.scale.y = dateText.scale.x;
        setPosition(btnPlay, posX, sprites[this.idx].position.y + sprites[this.idx].height / 2 + btnPlay.height);
        setPosition(dateText, posX, sprites[this.idx].position.y - sprites[this.idx].height / 2 - dateText.height);
      }
    }.bind({self:this, idx:i}));
    sprites[i].events.onInputDown.add(function() {
      clickPos.x = Math.floor(game.input.position.x);
      clickPos.y = Math.floor(game.input.position.y);
    });
    if (i == unlockedSprite) {
      this.createRibbon(sprites[i], this.selectedLevelsGroup);
    }
  }
  for (var i = 0;i < sprites.length;i++) {
    sprites[i].idxx = i;
    sprites[i].events.onInputUp.add(function(sprite) {
      if (Math.floor(game.input.position.x) == clickPos.x && Math.floor(game.input.position.y) == clickPos.y) {
        this.showLoadingScreen();
        setTimeout(function(idx) {
          this.playingLevel = imageFills[idx];
          this.playingLevel.position = sprites[idx];
          this.clickLevel(levelChosen, imageChosen);
        }.bind(this), 50, sprite.idxx);
      }
    }, this);
  }
  this.resizeQueue.forEach(function(element) {
    element();
  });
  this.hideLoadingScreen();
}, clickLevel:function(levelIndex, category) {
  soundBoard.clickEffect.play();
  this.showLoadingScreen();
  guiManager.loadLevel(levelIndex, category);
  this.hideLoadingScreen();
  this.screenGroup.visible = false;
}, resetImagePosition:function() {
  this.resizeQueue.forEach(function(element) {
    element();
  });
}, tranlatePosition:function(posX, posY, result, resolution) {
  resultSprite = result;
  var curr_width, curr_height;
  curr_width = resolution;
  curr_height = resolution;
  curr_posX = resultSprite.position.x;
  curr_posY = resultSprite.position.y;
  var resultDistanceX = posX - resultSprite.left;
  var resultDistanceY = posY - resultSprite.top;
  scale = curr_width / resolution;
  var distanceX = resultDistanceX / scale;
  var distanceY = resultDistanceY / scale + 100;
  translatedPosition = {};
  translatedPosition.x = Math.floor(distanceX);
  translatedPosition.y = Math.floor(distanceY);
  translatedPosition.scale = scale;
  return translatedPosition;
}, showLoadingScreen:function() {
  this.followingScreenGroup.visible = false;
  this.loadingGroup.visible = true;
}, hideLoadingScreen:function() {
  this.loadingGroup.visible = false;
  this.followingScreenGroup.visible = true;
}, createLoadingDots:function(posX, posY, size) {
  this.loadingGroup = game.add.group();
  dotsGroup = game.add.group();
  dotsGroup.position.x = posX;
  dotsGroup.position.y = posY;
  this.resizeQueue.push(function() {
    dotsGroup.position.x = game.width / 2;
    dotsGroup.position.y = game.height / 2;
  }.bind(this));
  var dotsColors = ["#0000FF", "#8A2BE2", "#FF0000", "#ffef00", "#74ff00", "#FA8072", "#FFDEAD", "#00ffd1"];
  var dots = [game.add.image(-50, +0, "loadingDot"), game.add.image(-35, +35, "loadingDot"), game.add.image(+0, +50, "loadingDot"), game.add.image(+35, +35, "loadingDot"), game.add.image(+50, +0, "loadingDot"), game.add.image(+35, -35, "loadingDot"), game.add.image(+0, -50, "loadingDot"), game.add.image(-35, -35, "loadingDot")];
  var idx = 0;
  dots.forEach(function(element) {
    setObjectAnchor(element, .5, .5);
    element.tint = "black";
    element.width = size;
    element.height = size;
    element.tint = "0x" + dotsColors[idx].substring(1);
    dotsGroup.addChild(element);
    idx++;
  });
  this.loadingGroup.addChild(dotsGroup);
  this.screenGroup.addChild(this.loadingGroup);
}, createTopPanel:function() {
  this.topPanelGroup = game.add.group();
  this.screenGroup.addChild(this.topPanelGroup);
  topPanelInfo = {};
  topPanelInfo.height = 100;
  topPanelInfo.width = game.width;
  topPanelInfo.y = topPanelInfo.height / 2;
  topPanelInfo.x = game.width / 2;
  var bannerName = this.rewardAvailable ? "banner_pink" : "banner";
  var topPanel = guiManager.buttonCreator.createSpriteImgButton(topPanelInfo.x, topPanelInfo.y, game.width + 10, topPanelInfo.height, bannerName, "pak_icons", function() {
    this.clickButtonGift();
  }, this, -1, this.topPanelGroup);
  this.banner = topPanel;
  this.claimNewPictureText = game.make.text(this.banner.position.x - topPanel.width / 18, topPanel.position.y + topPanel.height / 10, gameTexts.textFromID("ClaimNewImage"), {font:"50px bebas_font", fill:"black", fontSize:game.height / 25});
  this.nextRewardText = game.make.text(this.banner.position.x - topPanel.width / 18, topPanel.position.y + topPanel.height / 10, gameTexts.textFromID("NextRewardIn"), {font:"50px bebas_font", fill:"black", fontSize:game.height / 25});
  this.nextRewardText.visible = !this.rewardAvailable;
  this.claimNewPictureText.visible = this.rewardAvailable;
  setObjectAnchor(this.claimNewPictureText, .5, .5);
  setObjectAnchor(this.nextRewardText, .5, .5);
  this.topPanelGroup.addChild(this.claimNewPictureText);
  this.topPanelGroup.addChild(this.nextRewardText);
  const buttonSize = topPanel.height / 2;
  this.topPanelInfo = {height:topPanel.height};
  this.btn_rewards = guiManager.createSprite(topPanel.position.x, topPanel.position.y, buttonSize, buttonSize, "pak_icons", "star_noBg", this.topPanelGroup);
  this.btn_rewards.tint = "black";
  if (!this.rewardAvailable) {
    this.btn_rewards.frameName = "star_unavailable";
    this.btn_rewards.visible = false;
  } else {
    this.btn_rewards.visible = true;
  }
  var grey = "#" + GREY_COLOR.toString().substring(2);
  var startingTime = "00:00:00";
  this.rewardsTimeText = game.make.text(game.width * .4, topPanel.position.y, startingTime, {font:"50px bebas_font", fill:"black", fontSize:50});
  var clockIcon = guiManager.createSprite(game.width / 2, topPanel.position.y, buttonSize, buttonSize, "pak_icons", "clock", this.topPanelGroup);
  this.clock = clockIcon;
  if (this.rewardsTimeText.text === "00:00:00") {
    this.pulsegiftButton(this.btn_rewards);
  } else {
    this.btn_rewards.frameName = "star_noBg";
  }
  var bgSettings = guiManager.createImage(game.width - topPanel.height / 2, topPanel.position.y, topPanel.height, topPanel.height, "bgButton", this.topPanelGroup);
  var btn_settings = guiManager.buttonCreator.createSpriteImgButton(bgSettings.position.x, topPanel.position.y, buttonSize, buttonSize, "settings_icon", "pak_icons", this.clickButtonSettings, this, .25, this.topPanelGroup);
  bgSettings.visible = false;
  btn_settings.visible = false;
  this.menuButtonGroup = game.add.group();
  var btn_menu = guiManager.buttonCreator.createSpriteImgButton(topPanel.height / 2, topPanel.position.y, buttonSize, buttonSize, "back", "pak_icons", function() {
    this.clickButtonMenu();
  }, this, .25, this.topPanelGroup);
  this.btn_menu = btn_menu;
  btn_menu.visible = false;
  this.menuButtonGroup.visible = false;
  this.topPanelGroup.addChild(this.menuButtonGroup);
  this.resizeQueue.push(function() {
    topPanel.height = game.height / 7;
    topPanel.width = topPanel.height * 4;
    var buttonSize = topPanel.height / 2;
    topPanel.position.x = game.width * .5;
    topPanel.position.y = topPanel.height / 2;
    this.topPanelInfo.height = topPanel.height;
    btn_menu.width = buttonSize;
    btn_menu.height = buttonSize;
    setPosition(btn_menu, buttonSize, game.height - topPanel.position.y);
    btn_settings.width = buttonSize;
    btn_settings.height = buttonSize;
    bgSettings.height = topPanel.height;
    bgSettings.width = topPanel.height;
    setPosition(bgSettings, game.width - topPanel.height / 2, topPanel.position.y);
    setPosition(btn_settings, game.width - topPanel.height / 2, topPanel.position.y);
    setPosition(this.claimNewPictureText, this.banner.position.x, topPanel.position.y + topPanel.height / 4);
    setPosition(this.nextRewardText, this.banner.position.x, topPanel.position.y - topPanel.height / 4);
    var fontSize = game.height / 25;
    if (GAME_LANGUAGE == LANGUAGE_ES || GAME_LANGUAGE == LANGUAGE_IT || GAME_LANGUAGE == LANGUAGE_RU) {
      fontSize = game.height / 35;
    }
    this.claimNewPictureText.fontSize = fontSize;
    fontSize = game.height / 25;
    if (GAME_LANGUAGE == LANGUAGE_RU) {
      fontSize = game.height / 30;
    }
    if (GAME_LANGUAGE == LANGUAGE_EN) {
      fontSize = game.height / 25;
    }
    this.nextRewardText.fontSize = fontSize;
    this.btn_rewards.width = buttonSize;
    this.btn_rewards.height = buttonSize;
    setPosition(this.btn_rewards, game.width / 2, topPanel.position.y - buttonSize / 3);
    this.rewardsTimeText.fontSize = topPanel.height / 2;
    setPosition(this.rewardsTimeText, game.width * .52, topPanel.position.y + topPanel.height / 8);
    clockIcon.width = buttonSize;
    clockIcon.height = buttonSize;
    setPosition(clockIcon, game.width / 2 - clockIcon.width * 2.1, topPanel.position.y + topPanel.height / 10);
  }.bind(this));
  this.rewardsTimeText.anchor.x = .5;
  this.rewardsTimeText.anchor.y = .5;
  this.topPanelGroup.addChild(this.rewardsTimeText);
}, clickButtonMenu:function() {
  this.scrollSpeed = 0;
  this.loadingGroup.visible = false;
  soundBoard.clickEffect.play();
  this.followingScreenGroup = this.levelsGroup;
  this.settingsGroup.visible = false;
  this.menuButtonGroup.visible = false;
  this.selectedLevelsGroup.visible = false;
  this.levelsGroup.visible = true;
  this.btn_info.visible = true;
  this.btn_menu.visible = false;
  this.scrollDots.visible = true;
}, clickButtonGift:function() {
  if (!this.rewardAvailable) {
    this.btn_rewards.frameName = "star_unavailable";
    return;
  }
  soundBoard.clickEffect.play();
  soundBoard.claimEffect.play();
  this.btn_rewards.frameName = "star_unavailable";
  this.banner.frameName = "banner";
  this.claimNewPictureText.visible = false;
  this.nextRewardText.visible = true;
  randomCategory = Math.floor(Math.random() * categories.length);
  unlockLevel(randomCategory);
  this.createRibbon(this.categories[randomCategory], this.levelsGroup);
  this.clickButtonMenu();
  game.add.tween(this.followingScreenGroup).to({x:-this.categories[randomCategory].left + this.categories[randomCategory].width}, 750, Phaser.Easing.Linear.None, true, 0);
  this.categories[randomCategory];
  this.levelRewarded = randomCategory;
  var nextLevel = gameData[0].unlockedLevels[randomCategory] - 1;
  nextLevel = Math.floor(nextLevel / 3);
  imageName = categories[randomCategory] + "_" + nextLevel;
  if (game.cache.checkImageKey(imageName) == false) {
    game.load.image(imageName, IMAGE_FOLDER + "Levels/" + imageName + ".png");
    game.load.start();
  } else {
  }
  rewardCooldownTier = gameData[0].rewards.pickedUpTimes;
  if (rewardCooldownTier > rewardCooldown.length - 1) {
    rewardCooldownTier = rewardCooldown.length - 1;
  }
  gameData[0].rewards.pickedUpTimes++;
  gameData[0].rewards.availableTime = (new Date).getTime() + rewardCooldown[rewardCooldownTier] * 60 * 1E3;
  saveData();
  this.rewardPickedUpDate = gameData[0].rewards.availableTime;
  ARK_game_arena_connector.fireEventToArena("event_change");
}, createSettings:function() {
  var settingBtnSize = Math.min(game.width / 8, game.height / 7);
  this.settingsGroup = game.add.group();
  this.settingsGroup.visible = false;
  var settingsPos = {};
  settingsPos.x = game.width / 2;
  settingsPos.y = game.height / 2 - settingBtnSize;
  var effetsPos = {};
  effetsPos.x = game.width / 2;
  effetsPos.y = game.height / 2 + settingBtnSize;
  logoPos = {};
  logoPos.x = game.width / 2;
  logoPos.y = game.height * .75;
  logoPos.width = settingBtnSize * 1.4;
  logoPos.height = logoPos.width / 2;
  this.musicSetting = guiManager.buttonCreator.createSpriteImgButton(settingsPos.x, settingsPos.y, settingBtnSize, settingBtnSize, "music_on", "pak_icons", function() {
    this.clickButtonMusic();
  }, this, .15, this.topPanelGroup);
  var mussicWindow = guiManager.createImage(this.musicSetting.position.x, this.musicSetting.position.y, settingBtnSize * 2, settingBtnSize * 2, "buttonRing", this.settingsGroup);
  setObjectAnchor(this.musicSetting, .55, .5);
  mussicWindow.visible = false;
  this.effectsSetting = guiManager.buttonCreator.createSpriteImgButton(effetsPos.x, effetsPos.y, settingBtnSize, settingBtnSize, "sound_on", "pak_icons", this.clickButtonEffects, this, .15, this.topPanelGroup);
  var effectsWindow = guiManager.createImage(this.effectsSetting.position.x, this.effectsSetting.position.y, settingBtnSize * 2, settingBtnSize * 2, "buttonRing", this.settingsGroup);
  effectsWindow.visible = false;
  this.screenGroup.addChild(this.settingsGroup);
  this.resizeQueue.push(function() {
    var settingsPos = {};
    settingsPos.x = game.width - settingBtnSize * 1.2;
    settingsPos.y = settingBtnSize / 2;
    var effetsPos = {};
    effetsPos.x = game.width - settingBtnSize * .55;
    effetsPos.y = settingBtnSize / 2;
    this.effectsSetting.width = settingBtnSize / 2;
    this.effectsSetting.height = settingBtnSize / 2;
    effectsWindow.width = settingBtnSize;
    effectsWindow.height = settingBtnSize;
    setPosition(effectsWindow, this.effectsSetting.position.x, this.effectsSetting.position.y);
    setPosition(this.effectsSetting, effetsPos.x, effetsPos.y);
    this.musicSetting.width = settingBtnSize / 2;
    this.musicSetting.height = settingBtnSize / 2;
    mussicWindow.width = settingBtnSize;
    mussicWindow.height = settingBtnSize;
    setPosition(this.musicSetting, settingsPos.x, settingsPos.y);
    setPosition(mussicWindow, this.musicSetting.position.x, this.musicSetting.position.y);
  }.bind(this));
}, updateTime:function() {
  var currTime = new Date;
  var diffTime = gameData[0].rewards.availableTime - currTime.getTime();
  if (diffTime < 0) {
    this.rewardsTimeText.text = "00:00:00";
    this.rewardsTimeText.visible = false;
    this.clock.visible = false;
    this.btn_rewards.visible = true;
    this.rewardAvailable = true;
    if (this.btn_rewards.frameName !== "star_available") {
      this.pulsegiftButton(this.btn_rewards);
    }
    return;
  }
  this.rewardsTimeText.visible = true;
  this.clock.visible = true;
  this.btn_rewards.visible = false;
  this.rewardAvailable = false;
  var hours = Math.floor(diffTime / (1E3 * 60 * 60) % 24);
  var mins = Math.floor(diffTime / (1E3 * 60) % 60);
  var sec = Math.floor(diffTime / 1E3 % 60);
  var strHours;
  var strMins;
  var strSeconds;
  if (hours < 10) {
    strHours = "0" + Math.abs(hours);
  } else {
    strHours = hours;
  }
  if (mins < 10) {
    strMins = "0" + Math.abs(mins);
  } else {
    strMins = mins;
  }
  if (sec < 10) {
    strSeconds = "0" + Math.abs(sec);
  } else {
    strSeconds = sec;
  }
  this.rewardsTimeText.text = strHours + ":" + strMins + ":" + strSeconds;
}, clickButtonMusic:function() {
  const musicOn = soundBoard.toggleMusic();
  gameData[0].musicAllowed = musicOn;
  if (musicOn) {
    this.musicSetting.frameName = "music_on";
  } else {
    this.musicSetting.frameName = "music_off";
  }
  saveData();
}, clickButtonEffects:function() {
  const effectsOn = soundBoard.toggleEffects();
  gameData[0].effectsAllowed = effectsOn;
  if (effectsOn) {
    this.effectsSetting.frameName = "sound_on";
    soundBoard.clickEffect.play();
  } else {
    this.effectsSetting.frameName = "sound_off";
  }
  saveData();
}, pulsegiftButton:function(image) {
  if (image == null) {
    return;
  }
  if (!this.rewardAvailable) {
    image.frameName = "star_unavailable";
    return;
  }
  image.frameName = "star_noBg";
  this.banner.frameName = "banner_pink";
  this.claimNewPictureText.visible = true;
  this.nextRewardText.visible = false;
  const scale = this.topPanelInfo.height - image.height;
  tween = game.add.tween(image);
  tween.to({width:image.width + scale, height:image.height + scale}, 250, Phaser.Easing.Linear.None).onComplete.add(function() {
    var tween2 = game.add.tween(image);
    tween2.to({width:image.width - scale, height:image.height - scale}, 150, Phaser.Easing.Linear.None);
    tween2.onComplete.add(function() {
      this.pulsegiftButton(image);
    });
    tween2.start();
  });
}, clickButtonSettings:function() {
  ARK_game_arena_connector.fireEventToArena("event_change");
  if (soundBoard.effectsPlaying()) {
    this.effectsSetting.frameName = "soundOn";
  } else {
    this.effectsSetting.frameName = "soundOff";
  }
  if (soundBoard.musicPlaying()) {
    this.musicSetting.frameName = "musicOn";
  } else {
    this.musicSetting.frameName = "musicOff";
  }
  soundBoard.clickEffect.play();
  this.btn_menu.visible = true;
  this.followingScreenGroup.visible = !this.followingScreenGroup.visible;
  this.settingsGroup.visible = !this.settingsGroup.visible;
  this.scrollDots.visible = false;
  this.btn_info.visible = false;
}};

