var Preloader = function() {
};
var guiManager = new GUI;
var gameTexts = new GameTexts;
Preloader.prototype = {preload:function() {
  Preloader.instance = this;
  ARK_game_arena_connector.fireEventToArena("test_ready");
  game.stage.backgroundColor = 0;
  this.lastUpdate = Date.now();
  this.preloadDuration = 0;
  this.assetsLoaded = false;
  this.loadingProgress = 0;
  loadGameData();
  game.load.script("webfont", "//ajax.googleapis.com/ajax/libs/webfont/1.4.7/webfont.js");
  this.preloadGroup = game.add.group();
  this.preloadGroup.alpha = 0;
  this.createLoadingDots(game.height > game.width ? game.height / 30 : game.width / 30);
  game.add.tween(this.preloadGroup).to({alpha:1}, 350, Phaser.Easing.Linear.None, true, 0, 0, false);
  loadImages();
  game.load.onFileComplete.add(this.fileComplete, this);
  game.input.onDown.add(function() {
    if (game.paused) {
      game.paused = false;
    }
  });
}, fileComplete:function(progress, cacheKey, success, totalLoaded, totalFiles) {
  updateGameSize();
  game.canvas.style.marginTop = "0px";
  game.canvas.style.marginLeft = "0px";
  game.canvas.style.marginRight = "0px";
  var gameCanvas = document.getElementById("gameCanvas");
  var container = gameCanvas.parentElement;
  var offsetWidth = container.clientWidth - game.canvas.clientWidth;
  var offsetHeight = container.clientHeight - game.canvas.clientHeight;
  game.canvas.style.left = offsetWidth > 0 ? offsetWidth * 100 / container.clientWidth / 2 + "%" : 0;
  game.canvas.style.top = offsetHeight > 0 ? offsetHeight * 100 / container.clientHeight / 2 + "%" : 0;
  sizes.topRight = game.width * .2;
  sizes.bottomRight = game.width * .22;
  sizes.bottomLeft = game.width * .24;
  sizes.topLeft = game.width * .2;
  sizes.bgSize = game.width > game.height ? game.height : game.width;
  background.width = game.width;
  background.height = game.height;
  topLeft.width = sizes.topLeft;
  topLeft.height = sizes.topLeft * .82;
  topRight.width = sizes.topRight;
  topRight.height = sizes.topRight;
  bottomRight.width = sizes.bottomRight;
  bottomRight.height = sizes.bottomRight;
  bottomLeft.width = sizes.bottomLeft;
  bottomLeft.height = sizes.bottomLeft;
  gameLogoSize = game.width > game.height ? game.height : game.width;
  gameLogo.width = gameLogoSize;
  gameLogo.height = gameLogoSize;
  dots.forEach(function(element) {
    element.width = game.height > game.width ? game.height / 30 : game.width / 30;
    element.height = game.height > game.width ? game.height / 30 : game.width / 30;
  });
  setPosition(loadText, game.width / 2, gameLogo.bottom - textSize * 1.8);
  setPosition(gameLogo, game.width / 2, game.height / 2);
  setPosition(loadingGroup, game.width / 2, gameLogo.bottom - gameLogo.height * .28);
  setPosition(topLeft, 0, 0);
  setPosition(topRight, game.width - sizes.topRight, 0);
  setPosition(bottomLeft, 0, game.height - sizes.bottomLeft);
  setPosition(bottomRight, game.width - sizes.bottomRight, game.height - sizes.bottomRight);
  setPosition(background, game.width / 2, game.height / 2);
  if (progress < 30) {
    this.loadingProgress = 91;
  } else {
    if (progress > 91) {
      this.loadingProgress = progress;
    }
  }
  this.loadingGroup.rotation += 1;
  if (cacheKey == "lang_stringss") {
    gameTexts.create();
    loadLanguageSettings();
  }
  if (progress >= 100) {
    this.assetsLoaded = true;
  }
}, update:function() {
  var lastUpdateDif = Date.now() - this.lastUpdate;
  this.preloadDuration += lastUpdateDif;
  this.lastUpdate = Date.now();
  if (!this.assetsLoaded) {
    updateGameSize();
    sizes.topRight = game.width * .2;
    sizes.bottomRight = game.width * .22;
    sizes.bottomLeft = game.width * .24;
    sizes.topLeft = game.width * .2;
    sizes.bgSize = game.width > game.height ? game.height : game.width;
    background.width = game.width;
    background.height = game.height;
    topLeft.width = sizes.topLeft;
    topLeft.height = sizes.topLeft * .82;
    topRight.width = sizes.topRight;
    topRight.height = sizes.topRight;
    bottomRight.width = sizes.bottomRight;
    bottomRight.height = sizes.bottomRight;
    bottomLeft.width = sizes.bottomLeft;
    bottomLeft.height = sizes.bottomLeft;
    gameLogoSize = game.width > game.height ? game.height : game.width;
    gameLogo.width = gameLogoSize;
    gameLogo.height = gameLogoSize;
    dots.forEach(function(element) {
      element.width = game.height > game.width ? game.height / 30 : game.width / 30;
      element.height = game.height > game.width ? game.height / 30 : game.width / 30;
    });
    setPosition(loadText, game.width / 2, gameLogo.bottom - textSize * 1.8);
    setPosition(gameLogo, game.width / 2, game.height / 2);
    setPosition(loadingGroup, game.width / 2, gameLogo.bottom - gameLogo.height * .28);
    setPosition(topLeft, 0, 0);
    setPosition(topRight, game.width - sizes.topRight, 0);
    setPosition(bottomLeft, 0, game.height - sizes.bottomLeft);
    setPosition(bottomRight, game.width - sizes.bottomRight, game.height - sizes.bottomRight);
    setPosition(background, game.width / 2, game.height / 2);
    var gameCanvas = document.getElementById("gameCanvas");
    var container = gameCanvas.parentElement;
    var offsetWidth = container.clientWidth - game.canvas.clientWidth;
    var offsetHeight = container.clientHeight - game.canvas.clientHeight;
    game.canvas.style.left = offsetWidth > 0 ? offsetWidth * 100 / container.clientWidth / 2 + "%" : 0;
    game.canvas.style.top = offsetHeight > 0 ? offsetHeight * 100 / container.clientHeight / 2 + "%" : 0;
  }
  if (this.preloadDuration >= 2E3 && this.assetsLoaded === true) {
    this.assetsLoaded = false;
    this._create();
  }
  if (this.loadingGroup != null) {
    this.loadingGroup.rotation += .1;
  }
}, _create:function() {
  var twn = game.add.tween(this.loadText.scale).to({x:0, y:0}, 200, Phaser.Easing.Back.In, true, 200);
  twn.onComplete.addOnce(function() {
    game.state.start("StateGame");
  }, this);
}, create:function() {
}, createLoadingDots:function(size) {
  sizes = {};
  if (isWideScreen()) {
    sizes.topRight = game.width * .2;
    sizes.bottomRight = game.width * .22;
    sizes.bottomLeft = game.width * .24;
    sizes.topLeft = game.width * .2;
    sizes.bgSize = game.width > game.height ? game.height : game.width;
  } else {
    sizes.bgSize = game.width;
    sizes.topRight = game.width * .35;
    sizes.bottomRight = game.width * .36;
    sizes.bottomLeft = game.width * .35;
    sizes.topLeft = game.width * .45;
  }
  this.loadingGroup = game.add.group();
  const backgroundSize = sizes.bgSize;
  background = guiManager.createImage(game.width / 2, game.height / 2, game.width, game.height, "splashBG", this.preloadGroup);
  topLeft = guiManager.createSprite(0, 0, sizes.topLeft, sizes.topLeft * .82, "pak_bg", "bg_upLeft", this.preloadGroup);
  topRight = guiManager.createSprite(game.width - sizes.topRight, 0, sizes.topRight, sizes.topRight, "pak_bg", "bg_upRight", this.preloadGroup);
  bottomLeft = guiManager.createSprite(0, game.height - sizes.bottomLeft, sizes.bottomLeft, sizes.bottomLeft, "pak_bg", "bg_bottomLeft", this.preloadGroup);
  bottomRight = guiManager.createSprite(game.width - sizes.bottomRight, game.height - sizes.bottomRight, sizes.bottomRight, sizes.bottomRight, "pak_bg", "bg_bottomRight", this.preloadGroup);
  gameLogo = guiManager.createSprite(game.width / 2, game.height / 2, backgroundSize, backgroundSize, "pak_bg", "bg_logo", this.preloadGroup);
  this.gameLogo = gameLogo;
  setObjectAnchor(topLeft, 0, 0);
  setObjectAnchor(topRight, 0, 0);
  setObjectAnchor(bottomRight, 0, 0);
  setObjectAnchor(bottomLeft, 0, 0);
  this.textGroup = game.add.group();
  textSize = Math.floor(game.height * .03);
  this.loadText = game.make.text(game.width / 2, gameLogo.bottom - textSize * 1.8, "Loading", {font:textSize + "px bebas_font", fill:"white", stroke:"black", strokeThickness:5});
  this.loadText.visible = false;
  this.loadText.anchor.x = .5;
  this.loadText.anchor.y = .5;
  this.textGroup.addChild(this.loadText);
  this.loadingGroup.position.x = game.width / 2;
  this.loadingGroup.position.y = gameLogo.bottom - gameLogo.height * .28;
  loadingGroup = this.loadingGroup;
  loadText = this.loadText;
  var dotsColors = [255, 9055202, 16711680, 16772864, 7667456, 16416882, 16768685, 65489];
  var bigOffset = game.height > game.width ? game.height / 33 : game.width / 33;
  var smallOffset = bigOffset / 1.42857142857;
  dots = [game.add.image(-bigOffset, +0, "loadingDot"), game.add.image(-smallOffset, +smallOffset, "loadingDot"), game.add.image(+0, +bigOffset, "loadingDot"), game.add.image(+smallOffset, +smallOffset, "loadingDot"), game.add.image(+bigOffset, +0, "loadingDot"), game.add.image(+smallOffset, -smallOffset, "loadingDot"), game.add.image(+0, -bigOffset, "loadingDot"), game.add.image(-smallOffset, -smallOffset, "loadingDot")];
  var idx = 0;
  dots.forEach(function(element) {
    setObjectAnchor(element, .5, .5);
    element.tint = "black";
    element.width = size;
    element.height = size;
    element.tint = dotsColors[idx];
    this.loadingGroup.addChild(element);
    idx++;
  });
  window.addEventListener("resize", function(event) {
    updateGameSize();
    sizes.topRight = game.width * .2;
    sizes.bottomRight = game.width * .22;
    sizes.bottomLeft = game.width * .24;
    sizes.topLeft = game.width * .2;
    sizes.bgSize = game.width > game.height ? game.height : game.width;
    background.width = game.width;
    background.height = game.height;
    topLeft.width = sizes.topLeft;
    topLeft.height = sizes.topLeft * .82;
    topRight.width = sizes.topRight;
    topRight.height = sizes.topRight;
    bottomRight.width = sizes.bottomRight;
    bottomRight.height = sizes.bottomRight;
    bottomLeft.width = sizes.bottomLeft;
    bottomLeft.height = sizes.bottomLeft;
    gameLogoSize = game.width > game.height ? game.height : game.width;
    gameLogo.width = gameLogoSize;
    gameLogo.height = gameLogoSize;
    dots.forEach(function(element) {
      element.width = game.height > game.width ? game.height / 30 : game.width / 30;
      element.height = game.height > game.width ? game.height / 30 : game.width / 30;
    });
    setPosition(loadText, game.width / 2, gameLogo.bottom - textSize * 1.8);
    setPosition(gameLogo, game.width / 2, game.height / 2);
    setPosition(loadingGroup, game.width / 2, gameLogo.bottom - gameLogo.height * .28);
    setPosition(topLeft, 0, 0);
    setPosition(topRight, game.width - sizes.topRight, 0);
    setPosition(bottomLeft, 0, game.height - sizes.bottomLeft);
    setPosition(bottomRight, game.width - sizes.bottomRight, game.height - sizes.bottomRight);
    setPosition(background, game.width / 2, game.height / 2);
    var gameCanvas = document.getElementById("gameCanvas");
    var container = gameCanvas.parentElement;
    var offsetWidth = container.clientWidth - game.canvas.clientWidth;
    var offsetHeight = container.clientHeight - game.canvas.clientHeight;
    game.canvas.style.left = offsetWidth > 0 ? offsetWidth * 100 / container.clientWidth / 2 + "%" : 0;
    game.canvas.style.top = offsetHeight > 0 ? offsetHeight * 100 / container.clientHeight / 2 + "%" : 0;
  }, false);
  this.preloadGroup.addChild(this.loadingGroup);
  this.preloadGroup.addChild(this.textGroup);
}, yolo:function() {
}, createPreloadBG:function() {
  var loadText = game.make.text(game.width / 2, game.height * .7, "0%", {font:"50px bebas_font", fill:"white", stroke:"blue", strokeThickness:8});
  loadText.anchor.x = .5;
  loadText.anchor.y = .5;
  loadText.visible = false;
  var img = guiManager.createImage(game.width / 2, game.height / 2, game.width, game.height, "splash", this.preloadGroup);
  this.loadText = this.preloadGroup.addChild(loadText);
}};

