var resolutionX = window.innerWidth;
var resolutionY = window.innerHeight;
WebFontConfig = { google: { families: ["Roboto"] } };
var config = { audio: { disableWebAudio: true }, width: resolutionX, height: resolutionY, renderer: Phaser.CANVAS, antialias: true, forceSingleUpdate: true, mspointer: false };
var game;
var container;

var phaserInit = function (width, height, containerId) {
  ARK_game_arena_connector.init();
  ARK_game_arena_connector.registerAction("pause", onGamePause_ark);
  ARK_game_arena_connector.registerAction("resume", onGameResume_ark);
  
  if (containerId) {
    config.parent = containerId;
  }
  
  game = new Phaser.Game(config);
  game.pixelRatio = Math.min(2, window.devicePixelRatio || 1);
  
  container = document.getElementById(containerId);
  if (container) {
      document.addEventListener("mousedown", (event) => {
          if (container.contains(event.target)) {
              onGameResume_ark();
          } else {
              onGamePause_ark();
          }
      });
  }
  
  game.state.add("StateSplash", Splash);
  game.state.add("StatePreload", Preloader);
  game.state.add("StateGame", GameState);
  game.state.start("StateSplash");
};
window.addEventListener("contextmenu", function (e) {
  e.preventDefault();
});
window.addEventListener("touchend", function () {
  if (game === null) {
    return;
  }
  try {
    if (game.sound.context.state !== "running") {
      game.sound.context.resume();
    }
  } catch (err) {
  }
}, false);

function IEdetection() {
  var ua = window.navigator.userAgent;
  var msie = ua.indexOf("MSIE ");
  if (msie > 0) {
    return true;
  }
  var trident = ua.indexOf("Trident/");
  if (trident > 0) {
    return true;
  }
  var edge = ua.indexOf("Edge/");
  if (edge > 0) {
    return true;
  }
  return false;
}
var onGamePause_ark = function () {
  try {
    game.paused = true;
    game.sound.mute = true;
  } catch (e) {
  }
};
var onGameResume_ark = function () {
  try {
    game.paused = false;
    game.sound.mute = false;
  } catch (e) {
  }
};

